<?php defined('SYSPATH') or die('No direct script access.');
/**
 * Allows a template to be automatically loaded and displayed. Display can be
 * dynamically turned off in the controller methods, and the template file
 * can be overloaded.
 *
 * To use it, declare your controller to extend this class:
 * `class Your_Controller extends Template_Controller`
 *
 * $Id: template.php 3201 2008-07-23 17:05:49Z Shadowhand $
 *
 * @package    Core
 * @author     Kohana Team
 * @copyright  (c) 2007-2008 Kohana Team
 * @license    http://kohanaphp.com/license.html
 */
abstract class Website_Controller extends Template_Controller {
	

	// Template view name
	public $template = 'template';
	public $left = '';
	public $center = '';
	public $right = '';
	public $title_content = '';
	
	// Default to do auto-rendering
	public $auto_render = TRUE;

	/**
	 * Template loading and setup routine.
	 */
	public function __construct()
	{
		parent::__construct();
		$this->sawaal_meta_key = '';
		
		//GET DOCROOT
		$pageURL = 'http';
		$pageURL .= "://";
 		$pageURL .= $_SERVER["SERVER_NAME"].":".$_SERVER["SERVER_PORT"];
		$pageURL .= "/";	
		$this->root = $pageURL.substr(kohana::config("config.site_domain"),1); 
		//
		$this->session = Session::instance();
		$userid = cookie::get('userid');
		if($userid){
			$this->session->set('userid',$userid);
			cookie::delete('userid');
		}
		
		
                
                
		$this->userid = $this->session->get('userid');
		$this->username = $this->session->get('username');
		$this->usertype = $this->session->get('usertype');
		
		$this->template = new View($this->template);
                $this->model=new Menu_Model();
                
		
		//get the popular category
                $this->answers=new Answers_Model();
                $this->footer_category = $this->answers->get_all_category();
		
		/** GET THEME NAME **/
		
		if(!$this->session->get("theme_name")){
			$this->get_theme = $this->model->get_theme();
			$_SESSION["theme_name"] = $this->get_theme;
		}
		else{
			$this->get_theme = $this->session->get("theme_name");
		}
		
		/** GET ENABLE MODULE **/
		
		if(!$this->session->get("enable_module")){
			 $en_module = $this->model->get_module();
			 if(count($en_module) > 0 ){
				 foreach($en_module as $row){
					 $this->get_module[$row->id] = $row->name;
				 }
				 $_SESSION["enable_module"] = $this->get_module;
			}
			else{
				$this->get_module = array();
				$_SESSION["enable_module"] = $this->get_module;
			}
		}
		else{
			 $this->get_module = $this->session->get("enable_module");
			  $this->e_module = $this->session->get("mod_id");
		}

		/** GET MODERATOR PERMISSION  **/
		
		if(!$this->session->get("moderator_permission")){
			$this->get_moderator_permission = $this->model->get_moderator_permission();
                        if(count($this->get_moderator_permission)>0)
                        {
			        foreach($this->get_moderator_permission as $row){
				        $permission = array($row->action_add, $row->action_edit, $row->action_delete, $row->action_block);
			        }
			        $this->session->set("moderator_permission",$permission);
			}

			
		}
		else{
			$permission = $this->session->get("moderator_permission");
		}
		$this->moderator_add = $permission[0]; $this->moderator_edit = $permission[1];
		$this->moderator_delete = $permission[2];$this->moderator_block = $permission[3];
		
		/**  GET GENERAL SETTINGS [ META TAGS, TITLE, DESC, LOGO PATH] **/
		
		if(!$this->session->get("general_setting_info")){
			$g_info = $this->model->get_general_settings();
			if(count($g_info) > 0){
				foreach($g_info as $row){
					$this->general_setting_info = array("title" => $row->title,"meta_keywords" =>$row->meta_keywords,"meta_desc" =>$row->meta_desc, "logo_path" =>$row->logo_path);
				}
			}
			else{
				$this->general_setting_info = array("title" => "","meta_keywords" => "","meta_desc" => "" , "logo_path" => "");
			}
			$_SESSION["general_setting_info"] = $this->general_setting_info;
		}
		else{
			$this->general_setting_info = $this->session->get("general_setting_info");
		}

		//$this->get_pages = $this->model->get_pages();
		//$this->menu=$this->model->menu();

		//response variable
		$this->response=$this->session->get('Msg');
		$this->session->delete('Msg');
		
		
		
		$this->error_response=$this->session->get('Emsg');
		$this->session->delete('Emsg');

		//intiallizing the Docroot varaiable to whole project	
		
		$this->docroot = "http://".$_SERVER['HTTP_HOST'].trim($_SERVER['SCRIPT_NAME'],"index.php");
		$this->session->set('DOCROOT',$this->docroot);
		$this->file_docroot = $_SERVER['DOCUMENT_ROOT'];
		$this->model = new Profile_Model();
		$this->profile_info = $this->model->profile_info($this->userid);
                
		
	}
        
      
	/**
	 * Render the loaded template.
	 */
	public function _render()
	{
		if ($this->auto_render == TRUE)
		{
			// Render the template when the class is destroyed
			$this->template->render(TRUE);
		}
	}

} // End Template_Controller
