<?php defined('SYSPATH') or die('No direct script access.');
/**
 * Defines the user management,question and answer and general setting.
 *
 * @package    Core
 * @author     Saranraj
 * @copyright  (c) 2010 Ndot.in
 */

class Admin_Controller extends Website_Controller 
{

		 public $template = 'template/template';
		 public function __construct()
		 {
			 parent::__construct();
			 $this->model=new Admin_Model();
			 $this->ans =new Answers_Model();
			 $this->module="admin";
			 Nauth::is_login('',$this->docroot);
		 	/*User response messages*/
  			 $mes=Kohana::config('users_config.session_message');
                         $this->delete_user=$mes["delete_user"];
			 $this->user_access=$mes["user_access"];
			 $this->update_user=$mes["update_user"]; 
			 $this->set_permission=$mes["set_permission"];
			 $this->answer_delete=$mes["answer_delete"];
			 $this->question_delete=$mes["question_delete"];
			 $this->update_change=$mes["update_change"];
			 $this->change_theme=$mes["change_theme"];
			 $this->access_denied=$mes["access_denied"];
			 $this->email=$mes["email"];
			 $this->module_change=$mes["module_change"];
		 	 $this->module="admin";
		}
		
		/** SITE ANALYTICS **/
		
		 public function index()
		 {
		        $this->title_content = "Site Analytics";
		        
		 	if($this->usertype == -1 || $this->usertype == -2 ){
				 $this->template->title = "Site Analytics";
				 $this->analytics = $this->model->get_analytics();
				 $this->left = new View("general/left");
				 $this->right = new View("admin/analytics");
				 $this->template->content = new View("template/template2");
			}
			else{
				url::redirect($this->docroot."profile");
				die();
			}
		 }
		
		/** GENERAL SETTINGS **/	
					
		public function general_settings()
		{
			if($this->usertype != -1){
			 	url::redirect($this->docroot."admin");
			 }
			if($_POST){
				$title = html::specialchars($this->input->post("title"));
				$meta_keywords = html::specialchars($this->input->post("meta_keywords"));
				$meta_desc = html::specialchars($this->input->post("meta_description"));
				$logo = $_FILES["logo"]["name"];
				$this->model->update_general_setting($title,$meta_keywords,$meta_desc,$logo);
				$this->session->delete("general_setting_info");
				
			}
			$this->template->title="General Settings";
			$this->left = new View("general/left");
			$this->right = new View("general/admin_content");
			$this->title_content = "General Settings";
			$this->general_setting = $this->model->general_settings();
			$this->template->content = new View("template/template2");
		}
		
		/** MODULE PERMISSION **/
		
		public function module_permission()
		{
			if($_POST){
				$module = $this->input->post("permission");
				$userid = $this->input->post("usr_id");
				if(count($module) > 0 ){
					$module_permission = '';
					foreach($module as $row) {
						$module_permission.= $row.",";
					} 
					$modules = substr($module_permission,0,-1);
					$this->model->change_module_permission($modules,$userid);
				}
			}
			url::redirect($this->docroot."admin/manage_users");
			die();
		}
		
		//permission
		public function permission()
		{
			if($this->usertype != -1){
			 	url::redirect($this->docroot."admin");
			 }
			$this->template->title="Permission Settings";
			$this->get_modules=$this->model->get_modules();
			$this->get_permission=$this->model->get_permission();
				if($_POST)
				{
					$add=$this->input->post("add");
					$edit=$this->input->post("edit");
					$delete=$this->input->post("delete");
					$block=$this->input->post("block");
				
                                if(isset($add)) { $add=1 ; } else { $add=0;} 
				if(isset($edit)) { $edit=1;} else {$edit=0;}
				if(isset($delete)) { $delete=1;} else {$delete=0;}
				if(isset($block)) { $block=1;} else {$block=0;}
				
				$this->model->set_permission($add,$edit,$delete,$block);
				Nauth::setMessage(1,$this->set_permission);
				url::redirect($this->docroot."admin/permission");
				}
				
			 // template code
		 $this->left=new View("general/left");
		 $this->right=new View("general/permission");

		 $this->title_content = "Permission Settings";

		 $this->template->content=new View("template/template2");

		}
		//make moderator
		public function make_moderator()
		{
			if($this->usertype != -1){
			 	url::redirect($this->docroot."admin");
			 }
			$this->template->title="Make Moderator";
			$user_type=$this->input->get('user_type');
			$id=$this->input->get('id');
			$this->model->make_moderator($user_type,$id);
			Nauth::setMessage(1,$this->user_access);
			url::redirect($this->docroot.'admin/manage_users');
		}
		
		//manage users
		public function manage_users()
		{
			if($this->usertype != -1){
			 	url::redirect($this->docroot."admin");
			 }
			if($_POST){
				$uid = $this->input->post("user_id");
				$user = $this->input->post("user");
				$moderator = $this->input->post("moderator");
				$admin = $this->input->post("admin");
				$this->model->update_user_status($uid,$user, $moderator, $admin);
				url::redirect($this->docroot.'admin/manage_users');
			}
			$this->template->title = "Manage Users";
			$this->country_list=$this->model->get_country();
			$this->get_module_enabled = $this->model->get_enable_module(); 
			//get the moderator permission
			$this->get_moderator_permission = $this->model->get_moderator_permission();
			foreach($this->get_moderator_permission as $row)
			{
				$this->moderator_add=$row->action_add;
				$this->moderator_edit=$row->action_edit;
				$this->moderator_delete=$row->action_delete;
				$this->moderator_block=$row->action_block;
			}
			//pagging
			$page_no=$this->uri->last_segment();
			if($page_no==0 || $page_no=='index')
			$page_no = 1;
			$offset=10*($page_no-1); 
			$this->template->get_user=$this->model->getuser($offset,10);
			$this->total_admin_user=$this->model->getuser_count();
			$this->template->pagination = new Pagination(array
			 (
			 'base_url'       => '/admin',
			 'uri_segment'    => 'manage_users',
			 'items_per_page' => 10,
			 'total_items'    => $this->model->getuser_count(),
			 'style'         => 'classic' )
			 );

		 // template code
		 $this->left=new View("general/left");
		 $this->right=new View("general/manage_users");

		 $this->title_content = "Manage Users";

		 $this->template->content=new View("template/template2");
		}
		
		public function edit_profile()
		{
			if($this->usertype != -1){
			 	url::redirect($this->docroot."admin");
			 }
			if($_POST)
			{
				$userid=$this->input->post("userid");
				$first_name=$this->input->post("first_name");
				$last_name=$this->input->post("last_name");
				$email=$this->input->post("email");
				$street=$this->input->post("street");
				$city=$this->input->post("city");
				$country=$this->input->post("country");
				$postcode=$this->input->post("postcode");
				$phone=$this->input->post("phone");
				$mobile=$this->input->post("mobile");
				$dob=$this->input->post("dob");
				$gender=$this->input->post("gender");
				$this->update_user=$this->model->update_user($userid,$first_name,$last_name,$email,$street,$city,$country,$postcode,$phone,$mobile,$dob,$gender);
				
				Nauth::setMessage(1,$this->update_user); 
				url::redirect($this->docroot.'admin/manage_users/');
			}
		}
		//user access
		public function user_access()
		{
			if($this->usertype != -1){
			 	url::redirect($this->docroot."admin");
			 }
			$this->template->title="Access";
			$status=$this->input->get('status');
			$id=$this->input->get('id');
			$this->model->set_user_access($status,$id);
			Nauth::setMessage(1,$this->user_access);
			url::redirect($this->docroot.'admin/manage_users');
		}

		//delete user
		public function delete_user()
		{
			if($this->usertype != -1){
			 	url::redirect($this->docroot."admin");
			 }
			$id=$this->input->get("id");
			$this->template->title="Delete User";
			$this->template->delete_user=$this->model->delete_user($id);
			Nauth::setMessage(1,$this->delete_user); //set session message using library
			url::redirect($this->docroot.'admin/manage_users/');
		}
		
		//send the mail
		public function sentmail()
		{
		
			if($this->usertype != -1){
			 	url::redirect($this->docroot."admin");
			 }
			if(request::is_ajax())
			{
				$userid = $this->input->get('uid');
				$toid = $this->input->get('toid');
				$message = $this->input->get('msg');
	 		    $subject = $this->input->get('sub');
				 
				if($userid && $toid && $message)
				{ 
			
				$this->toid=$this->model->get_toid($toid);
				$this->fromid=$this->model->get_toid($userid);
			
				$mail_toid=$this->toid["mysql_fetch_row"]->email;
				$mail_fromid=$this->fromid["mysql_fetch_row"]->email;
			
				$headers = 'From: $this->fromid ' . "\r\n" .
	    'Reply-To: $this->fromid ' . "\r\n" .
	    'X-Mailer: PHP/' . phpversion();
		    
				mail($mail_toid, $subject, $message, $headers);

				echo "Mail sent successfully";	
				die();
				}
				else
				{
					
					echo "Cant able to access your request";
					die();
				}
			}
			else
			{
				$_SESSION["Msg"] =  "Invalid Call";
				die();
			}
		}
		
                //Yahoo  url Crawl Settings
		
		public function yahoo()
		{
			$this->get_category = $this->ans->get_all_category();
			$this->template->title="Crawl Yahoo Settings";
			$this->left=new View("general/left");
			$this->right=new View("general/manage_yahoo");
			$this->title_content = "Crawl Yahoo Settings";
			$this->template->content=new View("template/template2");
		}
		

	//Yahoo  data Crawl Settings
		
		public function yahoo_crawl_data()
		{
				$this->get_category = $this->ans->get_all_category();
				$this->all_info = $this->ans->get_all_urlinfo();
				$this->info = $this->ans->get_category_urlinfo();
				$this->template->title="Crawl Yahoo Settings";
				$this->left=new View("general/left");
				$this->right=new View("general/manage_yahoo_data");
				$this->title_content = "Crawl Yahoo Urls";
				$this->template->content=new View("template/template2");
			
		}
		
		 
		//modules settings
		public function modules()
		{	
			 if($this->usertype != -1){
			 	url::redirect($this->docroot."admin");
			 }
			 $this->template->title="Modules Settings";
			 $this->module_setting=$this->model->module_settings();
 
			 // template code
			 $this->left=new View("general/left");
			 $this->right=new View("general/modules");

			 $this->title_content = "Modules Setting";

		 	 $this->template->content=new View("template/template2");
		 
		}
		//activate the modules
		public function activate()
		{
			if($this->usertype != -1){
			 	url::redirect($this->docroot."admin");
			 }
			$id=$this->input->get("id");
			$status=$this->input->get("status");
			$this->template->title="Activate Modules";
			$this->template->activate=$this->model->module_activate($id,$status);
			
			//getting the module details
                        $this->get_module=$this->model->get_module();
                        /*$r="";
                        $s="";
                        //print_r($this->get_module); 
                        foreach($this->get_module as $mod)
                        {
                                if($mod->system_module==0)
                                {
                                        $r=$r."'".$mod->name."'"."=>".$mod->status.",\n";
                                }
                        }
                        $r1='$'."config['module_enable']= array(".$r.");";                                             
                      
                        
                        foreach($this->get_module as $module)
                        { 
                                if($module->status==0)
                                {
                                        $s=$s."MODPATH".".'".$module->name."',\n";
                                }
                        }
                        $s1='$'."config['modules'] = array ( ".$s.");";
                        $result = '<?php'."\n"." ".$r1."\n".$s1;
                        //check permission for application config file
                        /*$perms = substr(sprintf('%o', fileperms('application/config')), -4);
        	        if($perms!="0777")
		        {
			        $msg = '1';
			        $url=$this->docroot."admin/modules/"; 
			        ?>
			        <script type="text/javascript">
			        window.location = "<?PHP echo $url."?msg=$msg"; ?>";			 
			        </script>
			        <?php
		        }
		        else
		        { */                       
                        
                         //chmod($this->file_docroot.'/application/config/application.php', 0755);
                        /*$fp = fopen($this->file_docroot.'/application/config/application.php','w');
                        fwrite($fp,$result,strlen($result));
		        fclose($fp);*/		      		        
			Nauth::setMessage(1,$this->module_change); //set session message using library
			url::redirect($this->docroot.'admin/modules/');
			//}
			
		}


	//email
		 public function email()
		 {
		 	if($this->usertype != -1){
			 	url::redirect($this->docroot."admin");
			 }
			 $this->template->title="Email";
			
			 $this->template->email_all=$this->model->email_all();
			
			 if($_POST)
			 {
				 $from=$this->input->post('from');
				 $to1=$this->input->post('to');
				
				 $to=substr($to1,0,strlen($to1)-2);
				// echo $to;
				 $subject=$this->input->post('subject');
				 $message=$this->input->post('message');
				 //email to all
			
					$headers = 'From: admin@bit.com' . "\r\n" .
				'Reply-To: admin@bit.com' . "\r\n" .
				'X-Mailer: PHP/' . phpversion();
			
				mail($to, $subject, $message, $headers);
				Nauth::setMessage(1,$this->email);
				url::redirect($this->docroot.'admin/');
			
				// $file=$this->input->post('upload');
		
			}
			
			 // template code
			 $this->left=new View("general/left");
			 $this->right=new View("general/email_all");
	
			 $this->title_content = "Email";
	
			 $this->template->content=new View("template/template2");
  
	 }
	 //themes
	public function themes()
	{	
		if($this->usertype != -1){
			 	url::redirect($this->docroot."admin");
		}
		if($_POST){
			$theme = $this->input->post('theme');
			$this->set_theme = $this->model->set_theme($theme);
			Nauth::setMessage(1,$this->change_theme);
			$this->session->delete("theme_name");
			url::redirect($this->docroot.'admin/themes');
			die();
		}
		$this->template->title="change theme";
		$this->left=new View("general/left");
		$this->right=new View("general/themes_right");
		$this->title_content = "Themes";
		$this->template->content=new View("template/template2");
	}		
}
