<?php defined('SYSPATH') or die('No direct script access.');

/**
 * Defines the question and answers management
 *
 * @package    Core
 * @author     Saranraj
 * @copyright  (c) 2010 Ndot.in
 */


class Admin_answers_Controller extends Website_Controller 
{

		 public $template = 'template/template';
		 
		public function __construct()
		{
			parent::__construct();
			$this->module = "answers";
			if(!in_array($this->module, $this->session->get("enable_module"))) {
				url::redirect($this->docroot."admin");
				die();
			}
			 permission::check($this->module);
			 $this->model=new Admin_answers_Model();
                         Nauth::is_login('',$this->docroot);
		 	 
			 /*User response messages*/
  			 $mes=Kohana::config('users_config.session_message');
			 $this->answer_delete=$mes["answer_delete"];
			 $this->question_delete=$mes["question_delete"];
			 $this->update_change=$mes["update_change"];
			 $this->delete_category=$mes["delete_category"];
			 $this->add_category=$mes["add_category"];             		 
			 $this->update_category=$mes["update_category"];

		 }

		 //Answers management front page
		 public function index()
		 {
			
			$this->template->title="Manage Answer";
	
	                if($_POST)
	                {
	                        $answer = $this->input->post("answer");
	                        $answer_id = $this->input->post("answer_id");
	                        $this->model->update_answer($answer_id,$answer);
	                        Nauth::setMessage(1,"Answer has been Updated");
	                        url::redirect($this->docroot."admin_answers/");
	                }
			//pagging
			$page_no=$this->uri->last_segment();
			if($page_no==0 || $page_no=='index')
			$page_no = 1;
			$offset=10*($page_no-1); 
			$this->template->manage_answer=$this->model->manage_answer($offset,10);
			$this->total_admin_answer=$this->model->count_answer();
			$this->template->pagination = new Pagination(array
			 (
			 'base_url'       => 'admin_answers',
			 'uri_segment'    => 'index',
			 'items_per_page' => 10,
			 'total_items'    => $this->model->count_answer(),
			 'style'         => 'classic' )
			 ); 

	  		 // template code
			 $this->left=new View("general/left");
			 $this->right=new View("answers/manage_answer");
			 $this->title_content = "Manage Answers";
			 $this->template->content=new View("template/template2");
 
		 }

		//manage question
		public function manage_question()
		{
	
			$this->template->title="Manage Question";
	
			//pagging
			$page_no=$this->uri->last_segment();
			if($page_no==0 || $page_no=='index')
			$page_no = 1;
			$offset=10*($page_no-1); 
			$this->template->manage_question=$this->model->manage_question($offset,10);
			$this->total_admin_question=$this->model->count_question();
			$this->template->pagination = new Pagination(array
			 (
			 'base_url'       => 'admin_answers',
			 'uri_segment'    => 'manage_question',
			 'items_per_page' => 10,
			 'total_items'    => $this->model->count_question(),
			 'style'         => 'classic' )
			 ); 
		 // template code
		 $this->left=new View("general/left");
		 $this->right=new View("answers/manage_question");
		 $this->title_content = "Manage Questions";
		 $this->template->content=new View("template/template2");

		}
		
	        //sms question
		public function sms_question()
		{
			$this->template->title="Manage SMS Question";
	
			//pagging
			$page_no=$this->uri->last_segment();
			if($page_no==0 || $page_no=='index')
			$page_no = 1;
			$offset=10*($page_no-1); 

			$this->template->manage_question=$this->model->sms_question($offset,10);
			$this->total_admin_question=$this->model->count_sms_question();
			$this->template->pagination = new Pagination(array
			 (
			 'base_url'       => 'admin_answers',
			 'uri_segment'    => 'sms_question',
			 'items_per_page' => 10,
			 'total_items'    => $this->model->count_sms_question(),
			 'style'         => 'classic' )
			 ); 

			 // template code
			 $this->left=new View("general/left");
			 $this->right=new View("answers/manage_question");
			 $this->title_content = "Manage SMS Questions";
			 $this->template->content=new View("template/template2");
		}
		
		//delete answer
		public function delete_question()
		{
		
		        $id=$this->input->get("id");
		        $this->template->title="Delete Question";
		        $this->template->delete_answer=$this->model->delete_question($id);
		        Nauth::setMessage(1,$this->question_delete);
		        url::redirect($this->docroot.'admin_answers/manage_question/');
		}

		//question access
		public function question_access()
		{
		
		        $this->template->title="Question Access";
		        $status=$this->input->get('status');
		        $id=$this->input->get('id');

		        $this->model->set_question_access($status,$id);
		        Nauth::setMessage(1,$this->update_change);
		        url::redirect($this->docroot.'admin_answers/manage_question');
		}

		//answer access
		public function answer_access()
		{
		        $this->index();
		        $this->template->title="Answer Access";
		        $status=$this->input->get('status');
		        $id=$this->input->get('id');
		        $this->model->set_answer_access($status,$id);
		        Nauth::setMessage(1,$this->update_change);
		        url::redirect($this->docroot.'admin_answers/');
		}

		//delete answer
		public function delete_answer()
		{
		        $aid=$this->input->get("aid");
		        $qid=$this->input->get("qid");
		        
		        $this->template->title="Delete Answer";
		        $this->template->delete_answer=$this->model->delete_answer($aid,$qid);
		        Nauth::setMessage(1,$this->answer_delete);
		        url::redirect($this->docroot.'admin_answers/');
		}

		//manage category
		public function manage_category()
	   	{   
			if($_POST)
			{
			
			$category_id=$this->input->post("category_id");
			$category_name=$this->input->post("category_name");
			$type=$this->input->post("type");
			if($type=='update')
			{
				$this->model->update_category($category_id,$category_name);
				Nauth::setMessage(1,$this->update_category);
			}
			elseif($type=='add')
			{
				$this->model->insert_category($category_name);
				Nauth::setMessage(1,$this->add_category);
			}
			url::redirect($this->docroot.'admin_answers/manage_category/');
			}
			

			//pagination
			$page_no=$this->uri->last_segment();
			if($page_no==0 || $page_no=='index')
			$page_no = 1;
			//offset value from 3 to 6 
			$offset=15*($page_no-1); 
			$this->blog_category_count=$this->model->answers_category_count();
			//all records are stored in this variable
			$this->result=$this->model->get_answers_category($offset,15);
			//no of records count

			$this->template->pagination = new Pagination(array
			 (					
			 'base_url'       => 'admin_answers', //our controller/function(page)
			 'uri_segment'    => 'manage_category', //page(function)
			 'items_per_page' => 15,
			 'total_items'    => $this->blog_category_count,
			 'style'         => 'classic' )
			 );

			$this->template->title = "Answers Category Management";

			// template code
			$this->left=new View("general/left");
			$this->right=new View("answers/manage_category");
			$this->title_content = "Answers Category Management";
			$this->template->content=new View("/template/template2");	 	
		} 

		//delete cateogory
		public function delete_category()
		{

			$id=$this->input->get("id");
			
			$this->result=$this->model->delete_category($id);
			if($this->result)			
			{
			Nauth::setMessage(1,$this->delete_category);
			}
			url::redirect($this->docroot.'admin_answers/manage_category/');
			
		}
		//blog category list
	        public function get_answers_category($offset='',$noofpage='')
	        {
	                $result=$this->db->query("select * from ".$this->prefix."answers_category limit $offset,$noofpage");
	                return $result;
	        }	
	        //count the blog category
	        public function answers_category_count()
	        {
	                $result=$this->db->query("select * from ".$this->prefix."answers_category");
	                return count($result);
	        }


		//edit 
		public function  edit()
		{
			 $qid=$this->input->get("id");
			 
			// get the category to post
  			 $this->get_category=$this->model->get_all_category();
			 $this->question_info=$this->model->get_question_info($qid);
			 //update the question
			 if($_POST)
			 {
				$qid=$this->input->post("qid");
				$question=$this->input->post("question");
				$category=$this->input->post("category");
				$description=$this->input->post("description");
				$type = $this->input->post("type");
				$this->model->update_question($question,$category,$description,$qid);
				Nauth::setMessage(1,$this->update_change);
				if($type == "-1")
				{
				        url::redirect('/admin_answers/sms_question');
				}
				else
				{
				        url::redirect('/admin_answers/manage_question');
				}
			 }
			 // template code
			 $this->template->title="Edit Question";
			 $this->left=new View("general/left");
			 $this->right=new View("answers/edit_question");
			 $this->title_content = "Edit Question";
			 $this->template->content=new View("template/template2");
		}


}
