<?php defined('SYSPATH') or die('No direct script access.');

/**
 * Defines the forum management
 *
 * @package    Core
 * @author     Saranraj
 * @copyright  (c) 2010 Ndot.in
 */


class Admin_forums_Controller extends Website_Controller 
{

		 public $template = 'template/template';
		 public function __construct()
		 {
			 parent::__construct();
			  if(!in_array("forum", $this->session->get("enable_module"))) {
				url::redirect($this->docroot."admin");
				die();
			}
			$this->module="forums";
			permission::check("forum");
			
			 $this->model=new Admin_forums_Model();
             Nauth::is_login('',$this->docroot);
		 	/*User response messages*/
  			 $mes=Kohana::config('users_config.session_message');
			 $this->delete_category=$mes["delete_category"];
			 $this->add_category=$mes["add_category"];             		 
			 $this->update_category=$mes["update_category"];
			 $this->delete_forum=$mes["delete_forum"];
			 $this->update_forum=$mes["update_forum"];
		 
			}

		 public function index()
		 {
			if($_POST)
			{
			$forum_id=$this->input->post("forum_id");
			$topic=$this->input->post("topic");
			$category=$this->input->post("category");
			$topic_desc=$this->input->post("topic_desc");
			$this->model->update_forum($forum_id,$topic,$category,$topic_desc);
			Nauth::setMessage(1,$this->update_forum);
			url::redirect($this->docroot."admin_forums/index/");
			}
			$this->all_category=$this->model->all_category();
			//pagination
			$page_no=$this->uri->last_segment();
			if($page_no==0 || $page_no=='index')
			$page_no = 1;
			//offset value from 3 to 6 
			$offset=15*($page_no-1); 
			$this->cout=$this->model->count_forums(); 
			//all records are stored in this variable
			$this->result=$this->model->get_forums($offset,15);

			//no of records count
			$this->template->pagination = new Pagination(array
			 (					
			 'base_url'       => 'admin_forums', //our controller/function(page)
			 'uri_segment'    => 'index', //page(function)
			 'items_per_page' => 15,
			 'total_items'    => $this->cout,
			 'style'         => 'classic' )
			 );

			$this->template->title = "Recent Discussion";

			// template code
			$this->left=new View("general/left");
			$this->right=new View("forums/manage_forums");
			$this->title_content = "Discussion Forum Management";
			$this->template->content=new View("/template/template2");	 
		 }
		//delete forum
		public function delete_forum()
		{

			$id=$this->input->get("id");
			
			$this->result=$this->model->delete_forum($id);
			if($this->result)			
			{
			Nauth::setMessage(1,$this->delete_forum);
			}
			url::redirect($this->docroot.'admin_forums/index/');
			
		}
			 
	 	//edit news
	  	public function edit()
	   	{   
		
		$newsid = $this->input->get('nid');
		$this->template->editnews=$this->model->editnews($newsid);
		$view=new View("/admin_news");
		$this->template->content=$view;
		   
	 	} 

		public function manage_category()
	   	{   
			if($_POST)
			{
			$category_id=$this->input->post("category_id");
			$category_name=$this->input->post("category_name");
			$category_description=$this->input->post("category_description");
			if($category_id)
			{
				$this->model->update_category($category_id,$category_name,$category_description);
				Nauth::setMessage(1,$this->update_category);
			}
			else
			{
				$this->model->insert_category($category_name,$category_description);
				Nauth::setMessage(1,$this->add_category);
			}
			url::redirect($this->docroot.'admin_forums/manage_category/');
			}
			//pagination
			$page_no=$this->uri->last_segment();
			if($page_no==0 || $page_no=='index')
			$page_no = 1;
			//offset value from 3 to 6 
			$offset=15*($page_no-1); 
			$this->forum_category_count=$this->model->forums_category_count();
			//all records are stored in this variable
			$this->result=$this->model->get_forums_category($offset,15);
			//no of records count

			$this->template->pagination = new Pagination(array
			 (					
			 'base_url'       => 'forum', //our controller/function(page)
			 'uri_segment'    => 'index', //page(function)
			 'items_per_page' => 15,
			 'total_items'    => $this->forum_category_count,
			 'style'         => 'classic' )
			 );

			$this->template->title = "Manage Forum Category";

			// template code
			$this->left=new View("general/left");
			$this->right=new View("forums/manage_category");
			$this->title_content = "Discussion Forum Management";
			$this->template->content=new View("/template/template2");	 	
		} 
		//delete cateogory
		public function delete_category()
		{

			$id=$this->input->get("id");
			
			$this->result=$this->model->delete_category($id);
			if($this->result)			
			{
			Nauth::setMessage(1,$this->delete_category);
			}
			url::redirect($this->docroot.'admin_forums/manage_category/');
			
		}

}
