<?php defined('SYSPATH') or die('No direct script access.');
/**
 * Defines all database activity for admin
 *
 * @package    Core
 * @author     Saranraj
 * @copyright  (c) 2010 Ndot.in
 */

class Admin_Model extends Model
 {

         public function __construct()
	 {
		
                parent::__construct();
		$db=new Database();
		$this->session = Session::instance();
		include Kohana::find_file('../application/config','database',TRUE,'php');
		$this->config = $config ['default'];
		$this->prefix = $this->config['table_prefix'];
		$this->usertable = $config['usertable'];
		
	}
	
	//getting the moderator permission
	public function get_moderator_permission()
	{
	        $result=$this->db->query("select * from ".$this->prefix."members_permission where id=4");
	        return $result;
	}
	//get the modules list
	public function get_modules()
	{
	        $result=$this->db->query("select * from ".$this->prefix."modules");
	        return $result;
	}
	//make moderator
	public function make_moderator($user_type,$id)
	{
	        $this->db->query("update ".$this->prefix.$this->usertable." set user_type='$user_type' where id='$id' ");
	
	}
	
	//set the permission
	public function set_permission($add='',$edit='',$delete='',$block='')
	{
	        $this->db->query("update ".$this->prefix."members_permission set action_add='$add',action_edit='$edit',action_delete='$delete',action_block='$block' where id=4 ");
	}
	
	//get the permission lists
	public function get_permission()
	{
	        $result=$this->db->query("select * from ".$this->prefix."members_permission left join ".$this->prefix."members_role on ".$this->prefix."members_permission.members_role=".$this->prefix."members_role.id ");
	        return $result;
	}
	
	//update user
	public function update_user($userid,$first_name,$last_name,$email,$street,$city,$country,$postcode,$phone,$mobile,$dob,$gender)
	{
	        $this->db->query("update ".$this->prefix.$this->usertable." set name='$first_name',email='$email' where id='$userid'");
	        $this->db->query("update ".$this->prefix."users_profile set last_name='$last_name',country='$country',city='$city',street='$street',post_code='$postcode',city='$city',phone='$phone',mobile='$mobile',dob='$dob',gender='$gender' where user_id='$userid'");
	}

	//get country
	public function get_country()
	{
	        $result=$this->db->query("select * from ".$this->prefix."country");
	        return $result;
	}
	//get user email
	public function get_toid($toid)
	{
	        $result=$this->db->query("select * from ".$this->prefix.$this->usertable." where id='$toid'");
	        return $result;
	}

	//get the user list
	public function getuser($offset='',$noofpage='')
	{
	        $result=$this->db->query("select * from ".$this->prefix.$this->usertable." left join ".$this->prefix."users_profile on ".$this->prefix.$this->usertable.".id=".$this->prefix."users_profile.user_id  limit $offset,$noofpage");
	        return $result;
	}
	//count the user list
	public function getuser_count()
	{
	        $result=$this->db->query("select * from ".$this->prefix.$this->usertable." left join ".$this->prefix."users_profile on ".$this->prefix.$this->usertable.".id=".$this->prefix."users_profile.user_id ");
	        return count($result);
	}
	//set user access
	public function set_user_access($status,$id)
	{
	        $result=$this->db->query("update ".$this->prefix.$this->usertable." set user_status='$status' where id='$id'");
	        return $result;
	}
	//delete user
	public function delete_user($id)
	{
	        $this->db->query("delete from ".$this->prefix.$this->usertable." where id='$id' ");
	        $this->db->query("delete from ".$this->prefix."users_profile where user_id='$id' ");
	}

	 //update general settings
	 public function update_general_setting($title='',$meta_keywords='',$meta_desc='',$logo='')
	 {
	         $title=html::specialchars($title);
	         $meta_keywords=html::specialchars($meta_keywords);
	         $result=$this->db->query("update ".$this->prefix."general_settings set title='$title', meta_keywords='$meta_keywords', meta_desc='$meta_desc', logo_path='$logo' where id=1");
	            //save the logo
		        if($logo!='')
		        {
		        
	            	upload::save('logo');

		        }
		
	 }
	 
	 //general settings
	 public function general_settings()
	 {
	         $result=$this->db->query("select * from ".$this->prefix."general_settings limit 0,1");
	         return $result;
	 }
	 //modules settings
	 public function module_settings()
	 {
	         $result=$this->db->query("select * from ".$this->prefix."menus");
	         return $result;
	 }
	 //send the email to all
	 public function email_all()
	 {
	        $result=$this->db->query("select * from ".$this->prefix.$this->usertable." where user_type!=-1");
	        return $result;
	
	 }
         //set the theme
	 public function set_theme($theme='')
	 {
	         $result=$this->db->query("update ".$this->prefix."general_settings set theme='$theme' where id='1'");
	         return $result;
	 }
	 //modules activation
	 public function module_activate($id,$status)
	 {

	        $result=$this->db->query("update ".$this->prefix."menus set status='$status' where id='$id' ");
	        $this->session->delete('enable_module');
	        return $result;
	 }
	 //get modules to write in config
	public function get_module()
        {
        $result=$this->db->query("select * from ".$this->prefix."menus ");
        return $result;
        }
		
	//GET SITE ANALYTICS DETAILS
	
	public function get_analytics()
	{
		$analytics["users"] = $this->db->count_records("users");
		$modules = $this->db->select("name")
							->from("menus")
							->where(array("system_module" => 0 , "status" => 0))
							->get();
		foreach($modules as $row){
			if($row->name == "answers"){
				$analytics[$row->name] = $this->db->count_records("answer");
			}
			else{
				$analytics[$row->name] = $this->db->count_records($row->name);
			}
		}
		return $analytics;
	}
	
	/** UPDATE USERS PERMISSION (USER, MODERATOR, ADMIN) **/
	
	public function update_user_status($uid,$user, $moderator, $admin)
	{
		if($user){
			$type = $user;
		}
		elseif($moderator){
			$type = $moderator;
		}
		else{
			$type = $admin;
		}
		$this->db->update("users", array("user_type" => $type),array("id" => $uid));
		return;
	}
	
	/** GET ENABLED MODULE**/
	
	public function get_enable_module()
	{
		$module = $this->db->select("id","name")->from("menus")
								->where(array("system_module" => 0 , "status" => 0))
								->get();
		return $module;	
							
	}
	
	/** CHANGE MODULE PERMISSION **/
	
	public function change_module_permission($modules,$user_id)
	{
		$this->db->update("users",array("module_id" => $modules),array("id" => $user_id));
		return;
	}
}
