<?php defined('SYSPATH') OR die('No direct access allowed.'); 
/**
 * Defines all recent answers and question.
 *
 * @package    Core
 * @author     Saranraj
 * @copyright  (c) 2010 Ndot.in
 */

?>

<?php
	class Answers_Controller extends Website_Controller
	{
		public $template = 'template/template';

		 public function __construct()
		 {
			parent::__construct();
			$this->model=new Answers_Model();
			if(!in_array("answers", $this->session->get("enable_module"))) {
				url::redirect($this->docroot."profile");
				die();
			}
			
			
			//user response messages
			$mes=Kohana::config('users_config.session_message');
			$this->login=$mes["login"];
			$this->best_answer=$mes["best_answer"];
			$this->select_answer=$mes["select_answer"];
			$this->answer_delete=$mes["answer_delete"];
			$this->page_notfound= $mes["notfound"];
			$this->module="answers";
			
			
			$this->template->popular_cate=$this->model->popular_category();
			$this->all_category = $this->model->get_all_category();
			$this->topper=$this->model->best_answer_topper(0,4);
			
			
			$this->profile=new Profile_Model();
			
			
			
			
		 }

		//Answer home page.
		public function index()
		{
			//get the post value from front page to add question page
		
			if($_POST){
				$new_post=$this->input->post('new_post');
				url::redirect($this->docroot.'answers/add/?new_post='.$new_post.'');
			}
			
			
			
			//pagination

			$page_no=$this->uri->last_segment();
			if($page_no==0 || $page_no=='answers')
			$page_no = 1;
			$offset=10*($page_no-1);
	
			$this->template->show_question=$this->model->get_question($offset,$page_no, 10);
			$this->total=$this->model->get_recent_count();
			$this->template->pagination = new Pagination(array
			(
			 'base_url'       => 'answers',
			 'uri_segment'    =>'index',
			 'items_per_page' => 10,
			 'total_items'    => $this->total,
			 'style'         => 'classic' )
				 );

		
			
			$this->template->answered=$this->model->get_question1();

			$this->template->title = "Recent Questions";

			// template code
			$this->left=new View("answers_leftmenu");
			$this->center=new View("answers_content");
			$this->right=new View("right_side");
			
			$this->title_content = "Recent Questions &amp; Answers";
			$this->template->content=new View("/template/template3");

		}


		

		//display the both answers and question

	
		public function view()
		{
			 $this->question = $this->uri->last_segment();
			 $this->question_id =end(explode('_',$this->question));
		
			//display the Q&A
			$this->template->get_question=$this->model->display_question($this->question_id);
	
			
			
			//insert the answer 
		
			if($_POST)
			{
				$text=$this->input->post("text");
				$mobile_no=$this->input->post("mobile_no");
				$question_type=$this->input->post("question_type");
				$redirect_url=$this->input->post("redirect_url");
				$this->template->insert_answer=$this->model->post_answer($this->question_id,$text,$this->userid,$mobile_no,$question_type);
				
				url::redirect(''.$redirect_url.'');
			}
			if(count($this->template->get_question))
			{
			$this->poster_id=$this->template->get_question["mysql_fetch_array"]->id;
			$this->question_title = $this->template->get_question["mysql_fetch_array"]->question;
			
			$this->best_answer=$this->template->get_question["mysql_fetch_array"]->best_answer;

			//get the best answer	
			$this->get_best_answer=$this->model->get_best_answer($this->best_answer);

			$this->template->get_answer=$this->model->get_answer($this->question_id,$this->best_answer);
			$this->template->title = $this->question_title;
			
			//meta keyword 
			$this->sawaal_meta_key = $this->template->get_question["mysql_fetch_array"]->category_name.",answers,questions,online questions,sms questions,sms answers,sawaal answers,sawaal questions";
			 
			// template code
			$this->left=new View("answers_leftmenu");
			$this->right=new View("show");

			$this->title_content = $this->question_title ;

			$this->template->content=new View("/template/template2");
			}
			else
			{
                        Nauth::setMessage(-1,$this->page_notfound);
                        url::redirect($this->docroot.'answers/');  
			
			}

			

		}
		//close the question
		public function close()
		{
			
			$this->question = $this->uri->last_segment();
			$this->question_id =end(explode('_',$this->question));
		
			//display the Q&A
			$this->template->get_question=$this->model->display_question($this->question_id);
			$this->poster_id=$this->template->get_question["mysql_fetch_array"]->id;
			$this->question_title = $this->template->get_question["mysql_fetch_array"]->question;
			$this->best_answer=$this->template->get_question["mysql_fetch_array"]->best_answer;

			//get the best answer	
			$this->get_best_answer=$this->model->get_best_answer($this->best_answer);

			$this->template->get_answer=$this->model->get_answer($this->question_id,$this->best_answer);
			
			//insert the answer 
		
			if($_POST)
			{
				$text=$this->input->post("text");
				$redirect_url=$this->input->post("redirect_url");
				$this->template->insert_answer=$this->model->post_answer($this->question_id,$text,$this->userid);
				
				url::redirect(''.$redirect_url.'');
			}

			$this->template->title = $this->question_title;
			
			// template code
			$this->left=new View("answers_leftmenu");
			$this->right=new View("close");

			$this->title_content = $this->question_title;

			$this->template->content=new View("/template/template2");

		}
		
		//top questions

		public function top()
		{
			$this->template->title = "Top Questions";
	


			if($_POST)
			{
				$new_post=$this->input->post('new_post');
				url::redirect($this->docroot.'answers/add/?new_post='.$new_post.'');
			}

				//pagination
				$page_no=$this->uri->last_segment();
				if($page_no==0 || $page_no=='top')
				$page_no = 1;
				$offset=10*($page_no-1);
				$this->template->show_question=$this->model->get_top($offset,$page_no, 10);

				$this->total=$this->model->get_top_count();
				$this->template->pagination = new Pagination(array
				(
				 'base_url'       => '/answers/top',
				 'uri_segment'    =>'top',
				 'items_per_page' => 10,
				 'total_items'    => $this->total,
				 'style'         => 'classic' )
				);
				
			$this->template->answered=$this->model->get_question1();
	
			// template code
			$this->left=new View("answers_leftmenu");
			$this->center=new View("answers_content");
			$this->right=new View("right_side");

			$this->title_content = "Top Questions &amp; Answers";

			$this->template->content=new View("/template/template3");

		}

		
                //list out the all unanswered questions

		public function unanswered()
		{
		
			if($_POST)
			{
				$new_post=$this->input->post('new_post');
				url::redirect($this->docroot.'answers/add/?new_post='.$new_post.'');
			}
	
			$ids=$this->uri->last_segment();

			$this->total=$this->model->get_unanswered_count();
			
			//pagination
			$page_no=$this->uri->last_segment();
			if($page_no==0 || $page_no=='unanswered')
			$page_no = 1;
			$offset=10*($page_no-1);
			
				//$this->template->show_question=$model->get_top($offset,$page_no, 5);
				$this->template->show_question=$this->model->get_unanswered($offset,$page_no, 10);
	
				$this->template->pagination = new Pagination(array
				 (
				 'base_url'       => '/answers/unanswered',
				 'uri_segment'    =>'unanswered',
				 'items_per_page' => 10,
				 'total_items'    => $this->total,
				 'style'         => 'classic' )
				 );
	
			$this->template->count_unanswered=$this->model->get_unanswered_count();
	
			$this->template->title = "Unanswered Questions";
			// template code
			$this->left=new View("answers_leftmenu");
			$this->center=new View("answers_content");
			$this->right=new View("right_side");

			$this->title_content = "Unanswered Questions";

			$this->template->content=new View("/template/template3");

		}

		//display the current user answers

		public function my_answers()
		{
			//check the login
			Nauth::is_login('',$this->docroot);
			
			//pagination
			$page_no=$this->uri->last_segment();
			if (0 == $page_no || 'my_answers'==$page_no)
			$page_no = 1;
			$offset=10*($page_no-1);
			
			if($this->input->get("uid"))
			{
			        $uid = $this->input->get("uid");
			}
			else
			{
			        $uid = $this->userid;
			}
			
			$this->template->show_myquestion=$this->model->get_myanswer($uid,$offset,$page_no, 10);
			
			$this->total=$this->model->get_myanswer_count($uid);

			//$this->itemss = $items->get_items($offset,$page_no, 2);
			$this->template->pagination = new Pagination(array(
			'base_url'       => '/answers/my_answers',
			'uri_segment'    => 'my_answers',
			'items_per_page' => 10,
			'total_items'    => $this->total,
			 'style'         => 'classic' 
			));
			$this->template->title="My Answers";
			
			// template code
			$this->left=new View("answers_leftmenu");
			$this->right=new View("my_answers");

			$this->title_content = "My Answers (".$this->total.")";

			$this->template->content=new View("/template/template2");
			
			
		}
		
                public function toppers()
		{
			//check the login
			Nauth::is_login('',$this->docroot);
			
			//pagination
			$page_no=$this->uri->last_segment();
			if (0 == $page_no || 'toppers'==$page_no)
			$page_no = 1;
			$offset=10*($page_no-1);
		
			$this->topper=$this->model->best_answer_topper($offset,10);
                        $this->total = $this->model->count_toppers();
			$this->template->pagination = new Pagination(array(
			'base_url'       => '/answers/toppers',
			'uri_segment'    => 'toppers',
			'items_per_page' => 10,
			'total_items'    => $this->total,
			'auto_hide'      => TRUE,
			 'style'         => 'classic' 
			));
			
			$this->template->title="Top Answered Members";
			
			// template code
			$this->left=new View("answers_leftmenu");
			$this->right=new View("toppers_list");

			$this->title_content = "Top Answered Members";

			$this->template->content=new View("/template/template2");
			
			
		}
		
		//display the current user questions

		public function my_questions()
		{
			//check the login
			Nauth::is_login('',$this->docroot);
	
			//pagination
			$page_no=$this->uri->last_segment();
			if (0 == $page_no || 'my_questions'==$page_no)
			$page_no = 1;
			$offset=10*($page_no-1);
			//

			$this->template->show_myquestion=$this->model->get_myquestion($this->userid,$offset,$page_no, 10);
			$this->total=$this->model->get_myquestion_count($this->userid);
			//$this->itemss = $items->get_items($offset,$page_no, 2);
			$this->template->pagination = new Pagination(array(
			'base_url'       => 'answers',
			'uri_segment'    => 'my_questions',
			'items_per_page' => 10,
			'total_items'    => $this->total,
			 'style'         => 'classic' 
			));
		
			// template code
			$this->template->title="My Questions";
			$this->left=new View("answers_leftmenu");
			$this->center=new View("my_questions");
			$this->right=new View("right_side");
			$this->title_content = "My Questions (".$this->total.")";

			$this->template->content=new View("/template/template3");

		
		}

		//post the question
		public function add()
		{
			$this->template->title="Post the Question";
			// get the category to post
			$this->get_category=$this->model->get_all_category();
			$value = $this->input->get("new_post");
			//checking the login
			Nauth::is_login('',$this->docroot."users/signup/?val=".$value);
		
			if($_POST)
			{
				$question=$this->input->post('question');
				$description=$this->input->post('description');
				$category=$this->input->post("category");
		
				$this->template->display=$this->model->post_question($question,$description,$category,$this->userid);
				url::redirect($this->docroot.'answers/my_questions');
			}

			// template code
			$this->left=new View("answers_leftmenu");
			$this->right=new View("post_question");

			$this->title_content = "Ask a Question";

			$this->template->content=new View("/template/template2");


		}

		//show_category
		 public function show_category()
		 {
		  
			
			$category=$this->input->get('category');

			//pagging
		        $page_no=$this->uri->last_segment();
			if($page_no==0 || $page_no=='show_category')
			$page_no = 1;
			$offset=10*($page_no-1);
		
		        $this->total=$this->model->get_show_category_count($category);
			$this->template->show_question=$this->model->display_category($category,$offset,$page_no, 10);
			$this->template->pagination = new Pagination(array
				 (
			 'base_url'       => 'answers',
			 'uri_segment'    =>'show_category',
			 'items_per_page' => 10,
			 'total_items'    => $this->total,
			 'style'         => 'classic' )
				 );

                        if(count($this->template->show_question))
                        {
                         // template code
			$this->left=new View("answers_leftmenu");
			$this->right=new View("show_category");

			$this->title_content = $this->template->show_question["mysql_fetch_array"]->category_name;
			$this->template->title = "Questions in ".$this->template->show_question["mysql_fetch_array"]->category_name; 
                        $this->sawaal_meta_key = $this->template->show_question["mysql_fetch_array"]->category_name.",answers,questions,online questions,sms questions,sms answers,sawaal answers,sawaal questions";
			$this->template->content=new View("/template/template2");
                        }
                        else
                        {
                                Nauth::setMessage(-1,$this->page_notfound);
                                url::redirect($this->docroot.'answers/');  
                        }
                        
			
		
			 
		   }

	   //search form
	   public function search()
	   {
	
			$this->categories=$this->model->get_all_category();
			$this->template->title = "Search Answers";
			
			// template code
			$this->left=new View("answers_leftmenu");
			$this->right=new View("search_right");
	
			$this->title_content = "Search Questions &amp; Answers";
	
			$this->template->content=new View("/template/template2");

	   }
		   
		public function commonsearch()
		{
			$this->categories=$this->model->get_all_category();
			$search_value=html::specialchars($this->input->get('search_value'));
			//pagging
			$page_no=$this->uri->last_segment();
			if($page_no==0 || $page_no=='commansearch')
			$page_no = 1;
			$offset=10*($page_no-1);
			$this->total=$this->model->get_search_operation_count($search_value,'','');
			$this->template->show_question=$this->model->search_operation($search_value,'',$offset,$page_no, 10,'');
				
			$this->template->pagination = new Pagination(array
			(
			 'base_url'       => 'answers',
			 'uri_segment'    =>'commonsearch',
			 'items_per_page' => 10,
			 'total_items'    => $this->total,
			 'style'         => 'classic' )
			);
	
			$this->template->title = "Search Results";
			// template code
			$this->left=new View("answers_leftmenu");
			$this->right=new View("search_answer");
	
			$this->title_content = "Search Results (".$this->total.")";
	
			$this->template->content=new View("/template/template2");
		}

		//search answers
		public function search_answer()
		{
			$this->categories=$this->model->get_all_category();

			//get the input from user
			$search_value=$this->input->get('search_text');
			$search_category=$this->input->get('search_category');
			$unanswered=$this->input->get('unanswered');
			$this->q = $this->input->get('q');
			$this->t = '';
	
			//pagging
			$page_no=$this->uri->last_segment();
			if($page_no==0 || $page_no=='search_answer')
			$page_no = 1;
			$offset=10*($page_no-1);
			$this->total=$this->model->get_search_operation_count($search_value,$search_category,$unanswered);
			$this->template->show_question=$this->model->search_operation($search_value,$search_category,$offset,$page_no, 10,$unanswered );
				
			$this->template->pagination = new Pagination(array
			(
			 'base_url'       => 'answers',
			 'uri_segment'    =>'search_answer',
			 'items_per_page' => 10,
			 'total_items'    => $this->total,
			 'style'         => 'classic' )
			);
	
			$this->template->title = "Search Results";
			// template code
			$this->left=new View("answers_leftmenu");
			$this->center=new View("search_answer");
			$this->right=new View("right_side");
			
			$this->title_content = "Search Results (".$this->total.")";
	
			$this->template->content=new View("/template/template3");

		}

		//top category
		public function popular_category()
		{
			$this->template->popular_cate=$this->model->popular_category();
			$view=new View("top_category");
			$this->template->content=$view;
		}

		public function accept_solution()
		{
			$this->template->title="Accepted Answer";
			if($_POST)
			{
			        $answers_id=$this->input->post('close_best_answer'); 
			        $url=$this->input->post('redirect_url');
			
			        $question_id=$this->input->post('question_id');
			        $mobile_no=$this->input->post("mobile_no");
			        $question_type=$this->input->post("question_type");
			        $questioner_id=$this->input->post('questioner_id');

			        if(!empty($answers_id))			    
                                {
			        $this->template->accept_solution=$this->model->accept_solution($answers_id,$question_id,$mobile_no,$question_type,$questioner_id);
			        Nauth::setMessage(1,$this->best_answer);
			        url::redirect($this->docroot.'answers/view/'.$url.'');
			        }
			        else
			        {
			             Nauth::setMessage(-1,$this->select_answer);
			             url::redirect($this->docroot.'answers/close/'.$url.'');
			        }
			        
			}
		}
		
		public function best()
		{
		
			$this->template->title = 'Best Answers';
			
			$ids=$this->uri->last_segment();
			if($_POST)
			{
				$new_post=$this->input->post('new_post');
				url::redirect($this->docroot.'answers/post_question/?new_post='.$new_post.'');
			}

			
				//pagging
				$page_no=$this->uri->last_segment();
				if($page_no==0 || $page_no=='top')
				$page_no = 1;
				$offset=10*($page_no-1);
			
					$this->template->show_question=$this->model->best_solution($offset,$page_no, 10);
					$this->total=$this->model->get_best_solution_count();
					$this->template->pagination = new Pagination(array
					(
					 'base_url'       => 'best_solution',
					 'uri_segment'    =>'best_solution',
					 'items_per_page' => 10,
					 'total_items'    => $this->total,
					 'style'         => 'classic' )
					 );
				$this->template->title = "Best Answered Questions";
			  
				// template code
				$this->left=new View("answers_leftmenu");
				$this->center=new View("answers_content");
				$this->right=new View("right_side");
	
				$this->title_content = "Best Answers";
	
				$this->template->content=new View("/template/template3");

		}
		
		//delete answer
		public function delete_answer()
		{
		        $aid=$this->input->get("aid");
		        $qid=$this->input->get("qid");
		        $this->template->title="Delete Answer";
		        $this->template->delete_answer=$this->model->delete_answer($aid,$qid);
		        Nauth::setMessage(1,$this->answer_delete);
		        url::redirect('/answers/my_answers');	    
		        
		        
		}
		
}
?>
