<?php

/**
 * Defines the database activity for answers module
 *
 * @package    Core
 * @author     Saranraj
 * @copyright  (c) 2010 Ndot.in
 */

class Answers_Model extends Model
{

	public function __construct()
	{
		parent::__construct();
		$db=new Database();
		$this->update=new update_model_Model();
		include Kohana::find_file('../application/config','database',TRUE,'php');
		$this->config = $config ['default'];
		$this->prefix = $this->config['table_prefix'];
		$this->usertable = $config['usertable'];
		$mes=Kohana::config('users_config.session_message');
		$this->post_question=$mes["post_question"];
		$this->question_exist=$mes["question_exist"];
		$this->post_answer=$mes["post_answer"];
		$this->not_answered=$mes["not_answered"];
		$this->session = Session::instance();
		$this->user_id=$this->session->get('userid');
		$this->docroot = $this->session->get('DOCROOT');
	}
	//delete answer
	public function delete_answer($aid,$qid)
	{
	        $check_user=$this->db->query("SELECT user_id from ".$this->prefix."answer where answers_id='$aid'");
	       
	        if(count($check_user)>0)
	        {
	                if($check_user["mysql_fetch_array"]->user_id == $this->user_id) 
	                {
	                $result=$this->db->query("delete from ".$this->prefix."answer where answers_id='$aid'");
	                $this->db->query("update ".$this->prefix."question set answer=answer-1 where id='$qid'");
	                common::delete_update($aid,9);
                      	  return 1;
                  	}
                  	else
                  	{
                  	return 0;
                  	}
          	}
          	

	}
	
	//get the recent answers
	public function get_recent_answers()
	{
		$result=$this->db->query("select *,".$this->prefix.$this->usertable.".name as username,".$this->prefix."question.id as question_id,time as cdate from ".$this->prefix."question left join ".$this->prefix.$this->usertable." on ".$this->prefix."question.user_id=".$this->prefix.$this->usertable.".id group by ".$this->prefix."question.id desc limit 0,5 ");
		return $result;
	}

	//get all answers category
	public function get_all_category()
	{
		$result=$this->db->query("select * from ".$this->prefix."answers_category order by category_name asc");
		return $result;
	}
	
	//get un crawled url from  answers category
	public function get_category_urlinfo()
	{
		 $querystring = "select ".$this->prefix."answers_category.category_id as catid,category_name as catname,(select count(*) from ".$this->prefix."question_url where ".$this->prefix."question_url.category_id=catid and status='0') as count_url from ".$this->prefix."answers_category left join ".$this->prefix."question_url on ".$this->prefix."question_url.category_id = ".$this->prefix."answers_category.category_id  group by ".$this->prefix."answers_category.category_id order by  category_name asc";
		$result=$this->db->query($querystring);
		return $result;
	}
	
	//Get all categories un crawled urls
	
	public function get_all_urlinfo()
	{
		$querystring  = "select count(*) as count_all from ".$this->prefix."question_url where status='0'";
		$result=$this->db->query($querystring);
		return $result['mysql_fetch_array']->count_all;

	}
	//show the best answers
	public function best_solution($offset='',$pageno='',$noofpage='')
	{
	
		$result=$this->db->query("select *,".$this->prefix.$this->usertable.".name as username,".$this->prefix."question.id as question_id,time as cdate from ".$this->prefix."question left join ".$this->prefix."answers_category on ".$this->prefix."question.category=".$this->prefix."answers_category.category_id left join ".$this->prefix.$this->usertable." on ".$this->prefix."question.user_id=".$this->prefix.$this->usertable.".id left join ".$this->prefix."users_profile on ".$this->prefix.$this->usertable.".id=".$this->prefix."users_profile.user_id where ".$this->prefix."question.status=0 group by ".$this->prefix."question.id desc having ".$this->prefix."question.best_answer>0 limit $offset,$noofpage ");
		return $result;
	}
	//count the best answers
	public function get_best_solution_count()
	{
		$result=$this->db->query("select *,".$this->prefix.$this->usertable.".name as username,".$this->prefix."question.id as question_id,time as cdate from ".$this->prefix."question left join ".$this->prefix."answers_category on ".$this->prefix."question.category=".$this->prefix."answers_category.category_id left join ".$this->prefix.$this->usertable." on ".$this->prefix."question.user_id=".$this->prefix.$this->usertable.".id left join ".$this->prefix."users_profile on ".$this->prefix.$this->usertable.".id=".$this->prefix."users_profile.user_id where ".$this->prefix."question.status=0 AND ".$this->prefix."question.best_answer>0");
		$best_count=count($result);
		return $best_count;
	}

	//update the best answer id to question table
	public function accept_solution($answers_id,$question_id,$mobile_no='',$question_type='',$questioner_id='')
	{
	        if($answers_id)
	        {
	                $this->answered_info=$this->db->query("select user_id,answer from ".$this->prefix."answer where answers_id='$answers_id'");
		        foreach($this->answered_info as $row)
		        {
		                $answer_text=$row->answer;
		                $answered_id=$row->user_id;
		        }
		        
		$this->db->query("update ".$this->prefix."question set best_answer='$answers_id' where id='$question_id'");
		
		//update the user points
		$this->db->query("update ".$this->prefix."users_profile set total_points=total_points+1 where user_id='$answered_id'"); //update the user points	
	        $this->db->query("insert into ".$this->prefix."user_point(user_id,q_id,a_id,points,answer_type,cdate)values('$answered_id','$question_id', '$answers_id','3','-2',SYSDATE())"); //insert the normal user points history 
	        
	        }
	        
	        //send the SMS to question poster
		if($question_type==-1 && !empty($mobile_no))
		{
			$this->sms=new Sms_Controller();
			$this->sms->text_sms($mobile_no,$answer_text);
		}
		
	        
	}

	
	//get the recent questions
	public function get_question($offset='',$pageno='',$noofpage='')
	{
	
		$result=$this->db->query("select *,".$this->prefix.$this->usertable.".name as username,".$this->prefix."question.id as question_id,time as cdate from ".$this->prefix."question left join ".$this->prefix.$this->usertable." on ".$this->prefix."question.user_id=".$this->prefix.$this->usertable.".id left join ".$this->prefix."users_profile on ".$this->prefix.$this->usertable.".id= ".$this->prefix."users_profile.user_id left join ".$this->prefix."answers_category on ".$this->prefix."question.category=".$this->prefix."answers_category.category_id where ".$this->prefix."question.status=0 group by ".$this->prefix."question.id desc limit $offset,$noofpage ");
		return $result;
	}

	//count the recent questions
	public function get_recent_count()
	{
		$result=$this->db->query("select *,".$this->prefix.$this->usertable.".name as username,".$this->prefix."question.id as question_id,time as cdate from ".$this->prefix."question left join ".$this->prefix.$this->usertable." on ".$this->prefix."question.user_id=".$this->prefix.$this->usertable.".id left join ".$this->prefix."users_profile on ".$this->prefix.$this->usertable.".id= ".$this->prefix."users_profile.user_id left join ".$this->prefix."answers_category on ".$this->prefix."question.category=".$this->prefix."answers_category.category_id where ".$this->prefix."question.status=0 group by ".$this->prefix."question.id desc");
		$recent_count=count($result);
		return $recent_count;
	}

	//top question and answers
	public function get_top($offset='',$pageno='',$noofpage='')
	{
	
		$result=$this->db->query("select *,".$this->prefix.$this->usertable.".name as username,".$this->prefix."question.id as question_id,time as cdate from ".$this->prefix."question left join ".$this->prefix."answers_category on ".$this->prefix."question.category=".$this->prefix."answers_category.category_id left join ".$this->prefix.$this->usertable." on ".$this->prefix."question.user_id=".$this->prefix.$this->usertable.".id left join ".$this->prefix."users_profile on ".$this->prefix.$this->usertable.".id= ".$this->prefix."users_profile.user_id where ".$this->prefix."question.status=0 order by answer desc limit $offset,$noofpage");
		return $result;
	}

	//count the top questions
	public function get_top_count()
	{
		$result=$this->db->query("select *,".$this->prefix.$this->usertable.".name as username,".$this->prefix."question.id as question_id,time as cdate from ".$this->prefix."question left join ".$this->prefix."answers_category on ".$this->prefix."question.category=".$this->prefix."answers_category.category_id  left join ".$this->prefix.$this->usertable." on ".$this->prefix."question.user_id=".$this->prefix.$this->usertable.".id left join ".$this->prefix."users_profile on ".$this->prefix.$this->usertable.".id= ".$this->prefix."users_profile.user_id where ".$this->prefix."question.status=0 order by answer desc");
		$top_count=count($result);
		return $top_count;
	}

	public function profile_get_top($offset='',$pageno='',$noofpage='')
	{
	

		$result=$this->db->query("select *,".$this->prefix.$this->usertable.".name as username,".$this->prefix."question.id as question_id,time as cdate from ".$this->prefix."question left join ".$this->prefix.$this->usertable." on ".$this->prefix."question.user_id=".$this->prefix.$this->usertable.".id where ".$this->prefix."question.status=0 limit $offset,$noofpage");
		return $result;
	}
	//get unanswered lists
	public function get_unanswered($offset='',$pageno='',$noofpage='')
	{
		$result=$this->db->query("select *,".$this->prefix.$this->usertable.".name as username,".$this->prefix."question.id as question_id,time as cdate from ".$this->prefix."question left join ".$this->prefix."answers_category on ".$this->prefix."question.category=".$this->prefix."answers_category.category_id  left join ".$this->prefix.$this->usertable." on ".$this->prefix."question.user_id=".$this->prefix.$this->usertable.".id left join ".$this->prefix."users_profile on ".$this->prefix.$this->usertable.".id= ".$this->prefix."users_profile.user_id where ".$this->prefix."question.status=0 group by ".$this->prefix."question.id desc having answer=0 limit $offset,$noofpage");
		return $result;
	}
	//count un answered
	public function get_unanswered_count()
	{
		$result=$this->db->query("select *,".$this->prefix.$this->usertable.".name as username,".$this->prefix."question.id as question_id,time as cdate from ".$this->prefix."question left join ".$this->prefix."answers_category on ".$this->prefix."question.category=".$this->prefix."answers_category.category_id  left join ".$this->prefix.$this->usertable." on ".$this->prefix."question.user_id=".$this->prefix.$this->usertable.".id left join ".$this->prefix."users_profile on ".$this->prefix.$this->usertable.".id= ".$this->prefix."users_profile.user_id where ".$this->prefix."question.status=0 group by ".$this->prefix."question.id desc having answer=0");
		$unanswer_count=count($result);
		return $unanswer_count;
	}

	public function get_question1()
	{
		//print kohana::debug($answer_cate);
		$result1=$this->db->query("select * from ".$this->prefix."answer ");
		//$result1=$this->db->query("select ");
	
		return $result1;
	}

	
	//get my question
	public function get_myquestion($userid,$offset='',$pageno='',$noofpage='')
	{

		$result=$this->db->query("select *,".$this->prefix.$this->usertable.".name as username,".$this->prefix."question.id as question_id,time as cdate from ".$this->prefix."question left join ".$this->prefix."answers_category on ".$this->prefix."question.category=".$this->prefix."answers_category.category_id  left join ".$this->prefix.$this->usertable." on ".$this->prefix."question.user_id=".$this->prefix.$this->usertable.".id left join ".$this->prefix."users_profile on ".$this->prefix.$this->usertable.".id= ".$this->prefix."users_profile.user_id where ".$this->prefix."question.status=0 AND ".$this->prefix."question.user_id='$userid'  order by question_id desc limit  $offset,$noofpage");
		return $result;
	
	}

	//my question count
	public function get_myquestion_count($userid)
	{
		 $result=$this->db->query("select *,".$this->prefix.$this->usertable.".name as username,".$this->prefix."question.id as question_id,time as cdate from ".$this->prefix."question left join ".$this->prefix."answers_category on ".$this->prefix."question.category=".$this->prefix."answers_category.category_id  left join ".$this->prefix.$this->usertable." on ".$this->prefix."question.user_id=".$this->prefix.$this->usertable.".id left join ".$this->prefix."users_profile on ".$this->prefix.$this->usertable.".id= ".$this->prefix."users_profile.user_id where ".$this->prefix."question.status=0 AND ".$this->prefix."question.user_id='$userid'");
		  $count_q= count($result);
		  return $count_q;
	 
	}
	// get the my answers

	public function get_myanswer($userid,$offset='',$pageno='',$noofpage='')
	{

		$result=$this->db->query("select *,".$this->prefix.$this->usertable.".name as username,".$this->prefix."question.id as question_id,".$this->prefix."answer.id as answer_id,time_answer as cdate from ".$this->prefix."question,".$this->prefix."answer left join ".$this->prefix.$this->usertable." on ".$this->prefix."answer.user_id=".$this->prefix.$this->usertable.".id left join ".$this->prefix."users_profile on ".$this->prefix.$this->usertable.".id=".$this->prefix."users_profile.user_id where ".$this->prefix."answer.user_id='$userid' AND ".$this->prefix."answer.id=".$this->prefix."question.id  order by ".$this->prefix."answer.id desc limit $offset,$noofpage");
		return $result;
	
	}

	//my answer count
	public function get_myanswer_count($userid)
	{
		$result=$this->db->query("select *,".$this->prefix.$this->usertable.".name as username,".$this->prefix."question.id as question_id,".$this->prefix."answer.id as answer_id,time_answer as cdate from ".$this->prefix."question,".$this->prefix."answer left join ".$this->prefix.$this->usertable." on ".$this->prefix."answer.user_id=".$this->prefix.$this->usertable.".id left join ".$this->prefix."users_profile on ".$this->prefix.$this->usertable.".id=".$this->prefix."users_profile.user_id where ".$this->prefix."answer.user_id='$userid' AND ".$this->prefix."answer.id=".$this->prefix."question.id");
		$count_a=count($result);
		return $count_a;
	}
        //get the question id
        public function get_question_id($question='')
	{
		$querystring = "select id from ".$this->prefix."question where question like '$question%' ";
	        $result=$this->db->query($querystring);
	        return $result;
	}

	//get the Category Count
        public function get_category_count($category='')
	{
		$querystring = "select category_id from ".$this->prefix."answers_category where category_name = '$category'";
	        $result=$this->db->query($querystring);
	        return count($result);
	}
	
	//get the Category Count
        public function get_category_id($category='')
	{
		$querystring = "select category_id from ".$this->prefix."answers_category where category_name = '$category'";
	        $result=$this->db->query($querystring);
	        return $result["mysql_fetch_array"]->category_id;
	}
	//post the question
	
	public function post_question_crawl($question,$description,$category,$userid)
	{
		//echo $userid;
		$session=Session::instance();
		$question=html::specialchars($question);
		$description=html::specialchars($description);
		//echo $question;
		$result=$this->db->query("select count(*) as total_count from ".$this->prefix."question where question='$question'");
			if($result["mysql_fetch_array"]->total_count==0)
			{
				//$question=html::specialchars($question);
				$result=$this->db->query("insert into ".$this->prefix."question(question,question_description,user_id,type,category,time)values('$question','$description', '$userid','0','$category',SYSDATE())");
				$question_id=$result->insert_id();
				//$session_id=$this->session->get("session_id");
		
				//set the session message
				return $question_id;
				
			} 
			

	}

        //post the question
	
	public function post_question($question,$description,$category,$userid)
	{
		//echo $userid;
		$session=Session::instance();
		$question=html::specialchars($question);
		$description=html::specialchars($description);
		//echo $question;
		$result=$this->db->query("select count(*) as total_count from ".$this->prefix."question where question='$question'");
			if($result["mysql_fetch_array"]->total_count==0)
			{
				//$question=html::specialchars($question);
				$result=$this->db->query("insert into ".$this->prefix."question(question,question_description,user_id,type,category,time)values('$question','$description', '$userid','0','$category',SYSDATE())");
				$question_id=$result->insert_id();
				$this->update->updates_insert($userid,$question_id,8,'',$question);
				//$session_id=$this->session->get("session_id");
		
				//set the session message
				Nauth::setMessage(1,$this->post_question);
				url::redirect($this->docroot.'answers/my_questions');
			} 
			else
			{
				//set the session message
				Nauth::setMessage(-1,$this->question_exist);
			}

	}
	//get the question by category
	public function display_category($category,$offset='',$pageno='',$noofpage='')
	{

		$show_category=$this->db->query("select *,".$this->prefix.$this->usertable.".name as username,".$this->prefix."question.id as question_id,time as cdate from ".$this->prefix."question left join ".$this->prefix.$this->usertable." on ".$this->prefix."question.user_id=".$this->prefix.$this->usertable.".id left join ".$this->prefix."users_profile on ".$this->prefix.$this->usertable.".id=".$this->prefix."users_profile.user_id left join ".$this->prefix."answers_category on ".$this->prefix."question.category=".$this->prefix."answers_category.category_id where category='$category' AND ".$this->prefix."question.status=0 limit $offset,$noofpage");
		return $show_category;
	}
	//count the category answers and questions
	public function get_show_category_count($category)
	{
		$show_category=$this->db->query("select *,".$this->prefix.$this->usertable.".name as username,".$this->prefix."question.id as question_id,time as cdate from ".$this->prefix."question left join ".$this->prefix.$this->usertable." on ".$this->prefix."question.user_id=".$this->prefix.$this->usertable.".id  left join ".$this->prefix."users_profile on ".$this->prefix.$this->usertable.".id=".$this->prefix."users_profile.user_id left join ".$this->prefix."answers_category on ".$this->prefix."question.category=".$this->prefix."answers_category.category_id where category='$category'  AND ".$this->prefix."question.status=0 ");
		$show_category_count=count($show_category);
		return $show_category_count;
	}
	
	//popular category
	public function popular_category()
	{
		$popular_category=$this->db->query("SELECT category_id,".$this->prefix."answers_category.category_name as category_name, COUNT(".$this->prefix."question.category) as categ_count
		FROM ".$this->prefix."question left join ".$this->prefix."answers_category on ".$this->prefix."question.category=".$this->prefix."answers_category.category_id group by ".$this->prefix."question.category order by categ_count desc limit 0,5");
		
		return $popular_category;
	}
	
	//popular category
	public function recent_category()
	{
		$recent_category=$this->db->query("SELECT category_id,".$this->prefix."answers_category.category_name as category_name, COUNT(".$this->prefix."question.category) as categ_count
		FROM ".$this->prefix."question left join ".$this->prefix."answers_category on ".$this->prefix."question.category=".$this->prefix."answers_category.category_id group by ".$this->prefix."question.category order by ".$this->prefix."question.id desc limit 0,5");
		
		
		return $recent_category;
	}
	
	//best Answer topper
	public function best_answer_topper($offset='',$noofpage='')
	{
	
	$result=$this->db->query("select user_id,name,last_name,user_photo ,city,total_points from ".$this->prefix.$this->usertable." left join ".$this->prefix."users_profile on ".$this->prefix.$this->usertable.".id=".$this->prefix."users_profile.user_id where ".$this->prefix."users_profile.total_points!=0  order by total_points desc limit $offset,$noofpage");
	return $result;
	}
	public function count_toppers()
	{
           $result=$this->db->query("select user_id,name,last_name,user_photo ,city,total_points from ".$this->prefix.$this->usertable." left join ".$this->prefix."users_profile on ".$this->prefix.$this->usertable.".id=".$this->prefix."users_profile.user_id where ".$this->prefix."users_profile.total_points!=0  order by total_points desc ");
	return count($result);

	        
	}
	//search the questions and answers
	public function search_operation($search_value='',$search_category='',$offset='',$pageno='',$noofpage='',$unanswered='')
	{
		$search_value=html::specialchars($search_value);
		$query="select *,".$this->prefix.$this->usertable.".name as username,".$this->prefix."question.id as question_id,time as cdate from ".$this->prefix."question left join ".$this->prefix.$this->usertable." on ".$this->prefix."question.user_id=".$this->prefix.$this->usertable.".id left join ".$this->prefix."users_profile on ".$this->prefix.$this->usertable.".id= ".$this->prefix."users_profile.user_id left join ".$this->prefix."answers_category on ".$this->prefix."question.category=".$this->prefix."answers_category.category_id where ";
		
		if($search_value!='' && $search_category!='')
		{
			$query.="( ".$this->prefix."question.question  like '%$search_value%' OR ".$this->prefix."question.category='$search_category' )";
		}
		else if($search_value!='')
		{
			$query.="".$this->prefix."question.question  like '%$search_value%' ";
		}
		else if($search_category!='')
		{
			$query.=$this->prefix."question.category='$search_category' ";
		}
		else
		{
			$query.="1=1";
		}
		
		//checking unanswered question...
		if($unanswered=="on")
		{
			$query.=" AND ".$this->prefix."question.answer=0";
		}
			$query.=" limit $offset,$noofpage";
			
		
		$result=$this->db->query($query);
		return $result;
		
	}
	
	//count the search results

	public function get_search_operation_count($search_value='',$search_category='',$unanswered='')
	{
		$search_value=html::specialchars($search_value);
		$query="select *,".$this->prefix.$this->usertable.".name as username,".$this->prefix."question.id as question_id,time as cdate from ".$this->prefix."question left join ".$this->prefix.$this->usertable." on ".$this->prefix."question.user_id=".$this->prefix.$this->usertable.".id left join ".$this->prefix."users_profile on ".$this->prefix.$this->usertable.".id= ".$this->prefix."users_profile.user_id left join ".$this->prefix."answers_category on ".$this->prefix."question.category=".$this->prefix."answers_category.category_id where  ";
		
		if($search_value!='' && $search_category!='')
		{
			$query.="(".$this->prefix."question.question  like '%$search_value%' OR ".$this->prefix."question.category='$search_category' )";
		}
		else if($search_value!='')
		{
			$query.="".$this->prefix."question.question  like '%$search_value%' ";
		}
		else if($search_category!='')
		{
			$query.="".$this->prefix."question.category='$search_category' ";
		}
		else
		{ 
			$query.="1=1";
		}
		//checking unanswered question...
		if($unanswered=="on")
		{       
			$query.=" AND ".$this->prefix."question.answer=0";
		}
	
			$result=$this->db->query($query);
			return count($result);
	}
	
	//get display question
	public function display_question($question_id)
	{
	       
		$result=$this->db->query("select *,".$this->prefix.$this->usertable.".name as username,".$this->prefix."question.id as question_id,time as cdate from ".$this->prefix."question left join ".$this->prefix."answers_category on ".$this->prefix."question.category = ".$this->prefix."answers_category.category_id  left join ".$this->prefix.$this->usertable." on ".$this->prefix."question.user_id=".$this->prefix.$this->usertable.".id left join ".$this->prefix."users_profile on ".$this->prefix.$this->usertable.".id=".$this->prefix."users_profile.user_id where ".$this->prefix."question.id='$question_id'");
		return $result;
	}

	

	public function get_answer($answer_id,$best_answer_id)
	{

		$result=$this->db->query("select *,".$this->prefix.$this->usertable.".name as username,time_answer as cdate,".$this->prefix."answer.user_id as user_id   from ".$this->prefix."answer left join ".$this->prefix.$this->usertable." left join ".$this->prefix."users_profile on ".$this->prefix.$this->usertable.".id=".$this->prefix."users_profile.user_id on ".$this->prefix."answer.user_id=".$this->prefix.$this->usertable.".id where ".$this->prefix."answer.id='$answer_id' AND ".$this->prefix."answer.answers_id!='$best_answer_id' AND ".$this->prefix."answer.status=0 ");
		return $result;
	}
	
	//get the best answer
	public function get_best_answer($answer_id)
	{
		$result=$this->db->query("select *,".$this->prefix.$this->usertable.".name as username,time_answer as cdate,".$this->prefix."answer.user_id as user_id  from ".$this->prefix."answer left join ".$this->prefix.$this->usertable." left join ".$this->prefix."users_profile on ".$this->prefix.$this->usertable.".id=".$this->prefix."users_profile.user_id on ".$this->prefix."answer.user_id=".$this->prefix.$this->usertable.".id where ".$this->prefix."answer.answers_id='$answer_id' AND ".$this->prefix."answer.status=0 ");
		return $result;
	}

	
	public function post_answer($ids,$text,$userid,$mobile_no,$question_type)
	{
		if($ids!="" && $text!="")
		{
			$text=html::specialchars($text);
			$this->update->updates_insert($userid,$ids,9,'',$text);
			$result = $this->db->query("insert into ".$this->prefix."answer(id,answer,user_id,time_answer)values('$ids','$text', '$userid',SYSDATE())");
			$this->db->query("update ".$this->prefix."question set answer=answer+1 where id='$ids'");
			
			$answer_id=$result->insert_id(); //get the answer id from last query
			
			$get_answers_count=$this->db->query("select answer from ".$this->prefix."question where id='$ids'"); //get the answers count from question 
			
			//add the user points
			if($get_answers_count["mysql_fetch_array"]->answer>0)
			{
			        $this->db->query("update ".$this->prefix."users_profile set total_points=total_points+1 where user_id='$userid'"); //update the user points	
			        $this->db->query("insert into ".$this->prefix."user_point(user_id,q_id,a_id,points,answer_type,cdate)values('$userid','$ids', '$answer_id','1','0',SYSDATE())"); //insert the normal user points history 
			
			} 
			else
			{
			        $this->db->query("update ".$this->prefix."users_profile set total_points=total_points+2 where user_id='$userid'"); //update the user points	
			        $this->db->query("insert into ".$this->prefix."user_point(user_id,q_id,a_id,points,answer_type,cdate)values('$userid','$ids', '$answer_id','2','-2',SYSDATE())"); //insert the first one to answer user points history 
			
			}
			
			        //send the SMS to question poster
				if($question_type==-1 && !empty($mobile_no))
				{
					$this->sms=new Sms_Controller();
					if(strlen($text)>140)
					{
					        $text = substr($text,0,140)." More Info Visit Sawaal.com";
					}else{
					$text.=" More Info Visit Sawaal.com";
					}
					
					$this->sms->text_sms($mobile_no,$text);
				}
				
				//send mail to question author 
			if($question_type != -1)
			{
			        $result=$this->db->query(" SELECT user_id, question FROM ".$this->prefix."question WHERE id = '$ids' ");

                                $usrid=$result["mysql_fetch_array"]->user_id;
                                $friend_id=$userid;
                                $type="answered for a question";
                                $description='<a href='.$this->docroot.'answers/view/?question_id='.$ids.'&best_answer=0>'.htmlspecialchars_decode($result["mysql_fetch_array"]->question).'</a>'; 
			        Nauth::send_mail_id($usrid,$friend_id,$type,$description); 
			}
			//set the session message
			Nauth::setMessage(1,$this->post_answer);
			
			
		}
		else
		{
			//set the session message
			Nauth::setMessage(-1,$this->not_answered);
		}
	}

	
	   
	public function best_selection($answer_id)
	{
		//echo $answer_id;
		$result=$this->db->query("select *,time_answer as cdate,".$this->prefix.$this->usertable.".name as username from ".$this->prefix."answer left join ".$this->prefix.$this->usertable." on ".$this->prefix.$this->usertable.".id=".$this->prefix."answer.user_id left join ".$this->prefix."users_profile on ".$this->prefix.$this->usertable.".id =".$this->prefix."users_profile.user_id where answers_id=$answer_id");
		return $result;
	}
	
}
?>
