<?php 
/**
 * Defines all groups DATABASE activity
 *
 * @package    Core
 * @authors    Saranraj.c
 * @copyright  (c) 2010 Ndot.in
 */

class Groups_Model extends Model 
{
	public function __construct()
	{
		parent::__construct();
		$this->db = new Database;

		include Kohana::find_file('../application/config','database',TRUE,'php');
		$this->config = $config ['default'];
		$this->prefix = $this->config['table_prefix'];
		$this->usertable = $config['usertable'];
		$this->uidfield = $config['uidfield'];
		$this->unamefield = $config['unamefield'];
		$this->upass = $config['upass'];
		$this->uemail = $config['uemail'];
		$this->ustatus = $config['ustatus'];
		$this->utype = $config['utype'];
		//response message
		$mes=Kohana::config('users_config.session_message');
		$this->group_create=$mes["group_create"];
		$this->group_exist=$mes["group_exist"];
		$this->invalid_photo=$mes["invalid_photo"];
		$this->post_wall=$mes["post_wall"];
		$this->wall_error=$mes["wall_error"];
		$this->add_forum=$mes["add_forum"];
		$this->exist_forum=$mes["exist_forum"];
		$this->group_join=$mes["group_join"];
		$this->already_join=$mes["already_join"];
		$this->update=new update_model_Model();
		$this->session=Session::instance();
		$this->usr_id=$this->session->get('userid');
		$this->docroot = "http://".$_SERVER['HTTP_HOST'].trim($_SERVER['SCRIPT_NAME'],"index.php.");
	}
	//get my groups
	public function get_mygroups($uid,$offset,$noofpage)
	{
		$result=$this->db->query("select ".$this->prefix."groups.group_id,group_photo,".$this->prefix."groups.user_id,group_name,group_desc,group_category,member_count,create_date,name,user_photo,group_category_name from ".$this->prefix."group_members left join ".$this->prefix."groups on ".$this->prefix."group_members.group_id=".$this->prefix."groups.group_id left join ".$this->prefix.$this->usertable." on ".$this->prefix."groups.user_id=".$this->prefix.$this->usertable.".id left join ".$this->prefix."users_profile on ".$this->prefix.$this->usertable.".id=".$this->prefix."users_profile.user_id left join ".$this->prefix."group_category on ".$this->prefix."groups.group_category=".$this->prefix."group_category.group_category_id where group_status=1 AND ".$this->prefix."group_members.user_id='$uid' order by ".$this->prefix."groups.group_id limit $offset,$noofpage");
		return $result;
	}
	//count my groups
	public function count_mygroups($uid)
	{
		$result=$this->db->query("select ".$this->prefix."groups.group_id,group_photo,".$this->prefix."groups.user_id,group_name,group_desc,group_category,member_count,create_date,name,user_photo,group_category_name from ".$this->prefix."group_members left join ".$this->prefix."groups on ".$this->prefix."group_members.group_id=".$this->prefix."groups.group_id left join ".$this->prefix.$this->usertable." on ".$this->prefix."groups.user_id=".$this->prefix.$this->usertable.".id left join ".$this->prefix."users_profile on ".$this->prefix.$this->usertable.".id=".$this->prefix."users_profile.user_id left join ".$this->prefix."group_category on ".$this->prefix."groups.group_category=".$this->prefix."group_category.group_category_id where group_status=1 AND ".$this->prefix."group_members.user_id='$uid' order by ".$this->prefix."groups.group_id");
			return count($result);
	}
        //delete wall
	public function delete_wall($id)
	{
	        $result = $this->db->query("delete from ".$this->prefix."wall where wall_id='$id'");
	        common::delete_update('',28,$id);
	        return $result;
	}
	
	//get groups by category
	public function get_groups_by_category($cid,$offset,$noofpage)
	{
		$result=$this->db->query("select group_id,group_photo,".$this->prefix."groups.user_id,group_name,group_desc,group_category,member_count,create_date,name,user_photo,group_category_name from ".$this->prefix."groups left join ".$this->prefix.$this->usertable." on ".$this->prefix."groups.user_id=".$this->prefix.$this->usertable.".id left join ".$this->prefix."users_profile on ".$this->prefix.$this->usertable.".id=".$this->prefix."users_profile.user_id left join ".$this->prefix."group_category on ".$this->prefix."groups.group_category=".$this->prefix."group_category.group_category_id where group_status=1 AND group_category='$cid' order by group_id limit $offset,$noofpage");
		return $result;

	}
	//count the groups by category
	public function get_groups_category_count($cid)
	{
		$result=$this->db->query("select group_id,group_photo,".$this->prefix."groups.user_id,group_name,group_desc,group_category,member_count,create_date,name,user_photo,group_category_name from ".$this->prefix."groups left join ".$this->prefix.$this->usertable." on ".$this->prefix."groups.user_id=".$this->prefix.$this->usertable.".id left join ".$this->prefix."users_profile on ".$this->prefix.$this->usertable.".id=".$this->prefix."users_profile.user_id left join ".$this->prefix."group_category on ".$this->prefix."groups.group_category=".$this->prefix."group_category.group_category_id where group_status=1 AND group_category='$cid' order by group_id");
		return count($result);

	}
	//get popular groups lists
	public function get_popular_groups_list($offset='',$noofpage='')
	{
		$result=$this->db->query("select group_id,group_photo,".$this->prefix."groups.user_id,group_name,group_desc,group_category,member_count,create_date,name,user_photo,group_category_name from ".$this->prefix."groups left join ".$this->prefix.$this->usertable." on ".$this->prefix."groups.user_id=".$this->prefix.$this->usertable.".id left join ".$this->prefix."users_profile on ".$this->prefix.$this->usertable.".id=".$this->prefix."users_profile.user_id left join ".$this->prefix."group_category on ".$this->prefix."groups.group_category=".$this->prefix."group_category.group_category_id where group_status=1 order by member_count desc limit $offset,$noofpage");
		return $result;
	}

	//get groups lists
	public function get_groups_list($offset='',$noofpage='')
	{
		$result=$this->db->query("select group_id,group_photo,".$this->prefix."groups.user_id,group_name,group_desc,group_category,member_count,create_date,name,user_photo,group_category_name from ".$this->prefix."groups left join ".$this->prefix.$this->usertable." on ".$this->prefix."groups.user_id=".$this->prefix.$this->usertable.".id left join ".$this->prefix."users_profile on ".$this->prefix.$this->usertable.".id=".$this->prefix."users_profile.user_id left join ".$this->prefix."group_category on ".$this->prefix."groups.group_category=".$this->prefix."group_category.group_category_id  where group_status=1  order by group_id desc limit $offset,$noofpage");
		return $result;
	}	

	//count the groups
	public function get_groups_count()
	{
		$result=$this->db->query("select group_id,group_photo,".$this->prefix."groups.user_id,group_name,group_desc,group_category,member_count,create_date,name,user_photo,group_category_name from ".$this->prefix."groups left join ".$this->prefix.$this->usertable." on ".$this->prefix."groups.user_id=".$this->prefix.$this->usertable.".id left join ".$this->prefix."users_profile on ".$this->prefix.$this->usertable.".id=".$this->prefix."users_profile.user_id left join ".$this->prefix."group_category on ".$this->prefix."groups.group_category=".$this->prefix."group_category.group_category_id  where group_status=1 ");
		return count($result);
	}

	//groups information
	public function group_info($gid)
	{
		$result=$this->db->query("select group_id,group_photo,".$this->prefix."groups.user_id,group_name,group_desc,group_category,member_count,create_date,name,user_photo,group_category_name,group_access,website,location,cdesc from ".$this->prefix."groups left join ".$this->prefix.$this->usertable." on ".$this->prefix."groups.user_id=".$this->prefix.$this->usertable.".id left join ".$this->prefix."users_profile on ".$this->prefix.$this->usertable.".id=".$this->prefix."users_profile.user_id left join ".$this->prefix."group_category on ".$this->prefix."groups.group_category=".$this->prefix."group_category.group_category_id left join ".$this->prefix."country on ".$this->prefix."groups.group_country=".$this->prefix."country.cid where group_status=1 AND group_id='$gid' ");
		return $result;
	}	
	//get the groups information to edit
	public function edit_group($gid)
	{
		 $result=$this->db->query("select * from ".$this->prefix."groups where group_id='$gid'");
		 return $result;
	}
	//country lists
        public function get_country()
	{
		$select = "select * from ".$this->prefix."country";
		$result = $this->db->query($select);
		return $result;
	}	

	 //get groups category 
	 public function get_category()
	 {
		 $result=$this->db->query("select * from ".$this->prefix."group_category");
		 return $result;
	 }
	 //to display alldiscussion  category
	public function get_discuss_category()
	{
		$result=$this->db->query("select * from ".$this->prefix."forum_category order by forum_category");
		return $result;
	}

	//create group
	public function create_group($title='',$group_image,$country,$category,$access,$website,$desc='',$company,$user_id,$member='',$location)
	{
		$title=html::specialchars($title);
		$desc=html::specialchars($desc);
		$company = html::specialchars($company);
		$location = html::specialchars($location);
		
		if(!empty($title) && !empty($desc))
		{
			$result = $this->db->query("select count(*) as total_count from ".$this->prefix."groups where group_name='$title'");
			
			if($result["mysql_fetch_array"]->total_count == 0)
			{
			//upload the new photo

			$_FILES = Validation::factory($_FILES)
				->add_rules('group_image', 'upload::valid', 'upload::type[gif,jpg,png,jpeg]', 'upload::size[1M]');
		
			if ($_FILES->validate())
			{  

				$file_name = upload::save('group_image'); 
				$file_path=end(explode('.',$file_name)); 
				$userDoc=DOCROOT."upload/$file_name";
				//$userDoc=str_replace("/","\'",$userDoc);
				$userDoc=str_replace("'","",$userDoc);
			
				if($file_name)
				{
			$result=$this->db->query("INSERT INTO `".$this->prefix."groups` (`group_name`, `group_desc`, `group_category`, `group_access`, `company_name`, `member_count`, `website`, `user_id`, `location`, `group_country`) VALUES ('$title', '$desc', '$category', '$access', '$company', '$member', '$website', '$user_id', '$location', '$country')");
			$group_id=$result->insert_id();
			$this->update->updates_insert($user_id,$group_id,26,$title);
			
			$this->db->query("insert into ".$this->prefix."group_members(group_id,user_id)values('$group_id','$user_id')");
			
			$this->db->query("update ".$this->prefix."groups set member_count = member_count+1 where group_id = '$group_id'");
			
				$this->db->query("UPDATE `".$this->prefix."groups` set group_photo='$group_id.$file_path' where group_id='$group_id'");
				Image::factory($file_name)
					->resize(58, 60, Image::WIDTH)
					->save(DOCROOT.'public/group_photo/50/'.$group_id.'.'.$file_path.'');
				//$title=html_entity_decode($title);
				Image::factory($file_name)
					->save(DOCROOT.'public/group_photo/'.$group_id.'.'.$file_path.'');
					unlink($file_name);		
					Nauth::setMessage(1,$this->group_create); //set session message using library   
				}
				
			}
			else
			{
			        Nauth::setMessage(-1,$this->invalid_photo); //set session message using library
			        url::redirect($this->docroot.'groups/add/');
			}
                 }
                 else
                 {
                                Nauth::setMessage(-1,$this->group_exist); //set session message using library
			        url::redirect($this->docroot.'groups/add/');
                 }
                 
		}

	}
	//update the group
	public function update_group($title,$group_image,$country,$category,$access,$website,$desc,$company,$userid,$member,$location,$gid)
	{
	$title = html::specialchars($title);
	$desc = html::specialchars($desc);
	$company = html::specialchars($company);
	$location = html::specialchars($location);
	
		$this->result=$this->db->query("update ".$this->prefix."groups set group_name='$title',group_desc='$desc',group_category='$category',group_access='$access',company_name='$company',website='$website',location='$location',group_country='$country' where group_id='$gid'");
		
		//upload the new photo

			$_FILES = Validation::factory($_FILES)
				->add_rules('group_image', 'upload::valid', 'upload::type[gif,jpg,png,jpeg]', 'upload::size[1M]');
		
			if ($_FILES->validate())
			{  

				$file_name = upload::save('group_image'); 
				$file_path=end(explode('.',$file_name)); 
				$userDoc=DOCROOT."upload/$file_name";
				//$userDoc=str_replace("/","\'",$userDoc);
				$userDoc=str_replace("'","",$userDoc);
				$group_id=$gid;
				if($file_name)
				{
			
				$this->db->query("UPDATE `".$this->prefix."groups` set group_photo='$group_id.$file_path' where group_id='$group_id'");
				Image::factory($file_name)
					->resize(58, 60, Image::WIDTH)
					->save(DOCROOT.'public/group_photo/50/'.$group_id.'.'.$file_path.'');
				//$title=html_entity_decode($title);
				Image::factory($file_name)
					->save(DOCROOT.'public/group_photo/'.$group_id.'.'.$file_path.'');
					unlink($file_name);		   
				}
			}
	}
	//post the group wall

	public function post_wall($poster_id,$group_id,$wall)
	{
		$wall=html::specialchars($wall);
		if(!empty($wall))
		{
			$ins = $this->db->query("insert into ".$this->prefix."wall(poster_id,group_id,wall_text,wall_date,object_type) values('$poster_id','$group_id','$wall',now(),'-1')");
			$post_id = $ins->insert_id();

				$res=$this->db->query("SELECT group_name,user_id FROM ".$this->prefix."groups WHERE group_id='$group_id'");
				$grp_name=$res["mysql_fetch_array"]->group_name;
				$this->update->updates_insert($poster_id,$group_id,28,$grp_name,$post_id);
                                $usrid=$res["mysql_fetch_array"]->user_id;
                                $friend_id=$poster_id;
                                $type="group wall";
                                $description='<a href='.$this->docroot.'groups/view/?gid='.$group_id.'&best_answer=0>'.htmlspecialchars_decode($grp_name).'</a>'; 
                                Nauth::send_mail_id($usrid,$friend_id,$type,$description); 
				

			Nauth::setMessage(1,$this->post_wall); //set session message using library
		}
		else
		{
	 		Nauth::setMessage(-1,$this->wall_error); //set session message using library.
	 		
		}

	}
	//get group the wall
	public function get_wall($gid,$offset,$noofpage)
	{
		$result=$this->db->query("select wall_id,poster_id,wall_text,receiver_user_id,name,user_photo,wall_date from ".$this->prefix."wall left join ".$this->prefix.$this->usertable." on ".$this->prefix."wall.poster_id=".$this->prefix.$this->usertable.".id left join ".$this->prefix."users_profile on ".$this->prefix."wall.poster_id=".$this->prefix."users_profile.user_id where group_id='$gid' AND object_type= -1 order by wall_id desc limit $offset,$noofpage ");
		return $result;
	}

	//count the walls
	public function count_wall($gid)
	{
		$result=$this->db->query("select wall_id,poster_id,wall_text,receiver_user_id,name,user_photo,datediff(now(),wall_date) as wall_date from ".$this->prefix."wall left join ".$this->prefix.$this->usertable." on ".$this->prefix."wall.poster_id=".$this->prefix.$this->usertable.".id left join ".$this->prefix."users_profile on ".$this->prefix."wall.poster_id=".$this->prefix."users_profile.user_id where group_id='$gid' AND object_type= -1 order by wall_id desc ");
		return count($result);

	}
	
	//post the discussion
	
	public function create_forum($gid,$topic,$topic_desc,$userid,$disc_category)
	{ 
		if(!empty($topic) && !empty($topic_desc))
		{
		$result=$this->db->query("select count(*) as total_count from ".$this->prefix."forum where topic='$topic'");

			if($result["mysql_fetch_array"]->total_count==0)
			{
			$result=$this->db->query("INSERT INTO `".$this->prefix."forum` (`category_id`,`group_id` ,`author_id` ,`posts` ,`hit` ,`topic`,`topic_desc`,`object_type`)VALUES ('$disc_category','$gid','$userid', '0', '0', '$topic','$topic_desc','-1')");
				$id = $result->insert_id();
				$res=$this->db->query("SELECT group_name,user_id FROM `".$this->prefix."groups` WHERE group_id='$gid'");
				$grp_name=$res["mysql_fetch_array"]->group_name;
				$this->update->updates_insert($userid,$id,32,$grp_name);
                                $usrid=$res["mysql_fetch_array"]->user_id;
                                $friend_id=$userid;
                                $type="group discussion";
                                $description='<a href='.$this->docroot.'groups/discussion/?id='.$id.'&gid='.$gid.'>'.htmlspecialchars_decode($grp_name).'</a>'; 
                                Nauth::send_mail_id($usrid,$friend_id,$type,$description); 

			Nauth::setMessage(1,$this->add_forum);
			}
			else
			{
			Nauth::setMessage(-1,$this->exist_forum);
			}
		
		}
	}
	//get the discussion

	public function count_forums($gid)
	{
		$result=$this->db->query("select topic_id,author_id,posts,hit,datediff(now(),lpost) as lpost,topic,name,user_photo from ".$this->prefix."forum left join ".$this->prefix.$this->usertable." on ".$this->prefix."forum.author_id=".$this->prefix.$this->usertable.".id left join ".$this->prefix."users_profile on ".$this->prefix.$this->usertable.".id=".$this->prefix."users_profile.user_id where group_id='$gid'");
		return count($result);
	}

	//get the home page forum
	public function get_forums($gid,$offset='',$noofpage='')
	{
		$result=$this->db->query("select topic_id,author_id,posts,hit,lpost,topic,name,user_photo from ".$this->prefix."forum left join  ".$this->prefix.$this->usertable." on ".$this->prefix."forum.author_id=".$this->prefix.$this->usertable.".id left join ".$this->prefix."users_profile on ".$this->prefix.$this->usertable.".id=".$this->prefix."users_profile.user_id where group_id='$gid' order by topic_id desc limit $offset,$noofpage ");
		return $result;
	}
	//delete forum
	public function delete_discussion($id)
	{
		$result=$this->db->query("delete from ".$this->prefix."forum where topic_id='$id'");
		$this->db->query("delete from ".$this->prefix."updates where type_id='$id' AND action_id=32 ");
		common::delete_update($id, 32);
		return $result;
		
	}
	//discussion forum information here
	public function get_discussion_information($topic_id)
	{
		$result=$this->db->query("select topic_id,author_id,posts,hit,lpost,topic,user_photo,topic_desc,name from ".$this->prefix."forum left join ".$this->prefix.$this->usertable." on ".$this->prefix."forum.author_id=".$this->prefix.$this->usertable.".id left join ".$this->prefix."users_profile on ".$this->prefix.$this->usertable.".id=".$this->prefix."users_profile.user_id where topic_id='$topic_id' AND object_type=-1 ");
		return $result;


	}

	//post the comments for forum
	public function post_comment($id='',$comments='',$userid='',$gid='')
	{
		$result=$this->db->query("INSERT INTO ".$this->prefix."forum_discussion (`topic_id` ,`commentor_id`,`desc` )VALUES ('$id', '$userid','$comments')");
		
				$res=$this->db->query("SELECT group_name FROM `".$this->prefix."groups` WHERE group_id='$gid'");
				$grp_name=$res["mysql_fetch_array"]->group_name;
				$this->update->updates_insert($userid,$id,33,$grp_name);

		return $result;
	}
	//update the date to find last active date
	public function updatedate($id)
	{

		$result=$this->db->query("UPDATE ".$this->prefix."forum SET lpost=now() WHERE topic_id='$id'");
		return $result;
	}

	//update the comments count to forum
	public function updatepost($id)
	{
		$result=$this->db->query("UPDATE ".$this->prefix."forum SET posts=posts+1 WHERE topic_id='$id'");
		return $result;
	}
	//for discussion page pagenation
	public function count_discussion($id)
	{
		$result=$this->db->query("select * from ".$this->prefix."forum_discussion where topic_id='$id'");
		return count($result);
	}
	
	//get the comments for forum			
	public function discuss($id,$offset='',$noofpage='')
	{
		$result=$this->db->query("select *,cdate from ".$this->prefix."forum_discussion left join ".$this->prefix.$this->usertable." on ".$this->prefix."forum_discussion.commentor_id=".$this->prefix.$this->usertable.".id left join ".$this->prefix."users_profile on ".$this->prefix.$this->usertable.".id=".$this->prefix."users_profile.user_id where topic_id='$id' order by discuss_id desc limit $offset,$noofpage");
		return $result;
	}

      //upload photo deatils
      public function insert_photo($userid, $gid, $upload_title, $upload_description, $photo_name)
      {
          $upload_title = html::specialchars($upload_title);
          $upload_description = html::specialchars($upload_description);
          $photo_name = html::specialchars($photo_name);
          $result = $this->db->query("insert into ".$this->prefix."photos(album_id,user_id,photo_title,photo_desc,photo_date,photo_name,object_type)values('$gid','$userid','$upload_title','$upload_description',sysdate(),'$photo_name',-1)");


          			$photo_id = $result->insert_id();
				$res=$this->db->query("SELECT group_name,user_id FROM `".$this->prefix."groups` WHERE group_id='$gid'");
				$grp_name=$res["mysql_fetch_array"]->group_name;
				$this->update->updates_insert($userid,$photo_id,29,$grp_name);
				$usrid=$res["mysql_fetch_array"]->user_id;
                                $friend_id=$userid;
                                $type="group photo";
                                $description='<a href='.$this->docroot.'groups/zoom/?photo_id='.$photo_id.'&gid='.$gid.'>'.htmlspecialchars_decode($grp_name).'</a>'; 
                                Nauth::send_mail_id($usrid,$friend_id,$type,$description); 
				
				
				
      
	  //save image in file
          $id = $result->insert_id();
          $_FILES = Validation::factory($_FILES)->add_rules('upload_photo', 'upload::valid', 'upload::type[gif,jpg,png,JPG,JPEG]', 'upload::size[1M]');
          if ($_FILES->validate()) 
	  {  
			$filename = upload::save('upload_photo');
            		$exact_file_name=end(explode("/",$filename));
		 	$file_path=substr($filename,-3);
			$userDoc=DOCROOT."upload/$exact_file_name";


	      //$userDoc = str_replace("/", "\'", $userDoc);
              $userDoc = str_replace("'", "", $userDoc);
              $input = getimagesize($userDoc);
              $width = current($input);
              $height = next($input);

		      if ($filename) 
		      {
			  //size 100*100
		          if ($width < 100 && $height < 100) 
			  {
		              Image::factory($filename)->resize($width, $height, Image::WIDTH)->save(DOCROOT . '/public/group_member_photo/' . $id . '.' . $file_path . '');
		          } 
			  else 
			  {
		              Image::factory($filename)->resize(100, 100, Image::WIDTH)->save(DOCROOT . '/public/group_member_photo/' . $id . '.' . $file_path . '');
		          }
			  // size 50*50
		          Image::factory($filename)->resize(50, 50, Image::WIDTH)->save(DOCROOT . '/public/group_member_photo/50/' . $id . '.' . $file_path . '');
	
			  //image own size
		          if ($width < 650 && $height < 600) 
			  {
		              Image::factory($filename)->save(DOCROOT . '/public/group_member_photo/normal/' . $id . '.' . $file_path . '');
		          } else {
		              Image::factory($filename)->resize(650, 600, Image::WIDTH)->save(DOCROOT . '/public/group_member_photo/normal/' . $id . '.' . $file_path . '');
		          }
				unlink($filename);
		      }
          }

      }
      //get group photos
      public function show_photo($gid, $offset = '',$noofpage = '')
      {
          $result = $this->db->query("select * from ".$this->prefix."photos where album_id='$gid' AND object_type=-1 limit $offset,$noofpage");
          return $result;
      }

      //count the photos count
      public function get_count_show($gid)
      {
          $result = $this->db->query("select * from ".$this->prefix."photos where album_id='$gid' AND object_type=-1 ");
          return count($result);
      }
	  //edit photo
      public function edit_photo($photo_id, $photo_title)
      {
          $photo_title = html::specialchars($photo_title);
          $result = $this->db->query("update ".$this->prefix."photos set photo_title='$photo_title' where photo_id='$photo_id'");
          return $result;
      }
	 //delete photo
      public function delete_photo($photo_id)
      {
          $result = $this->db->query("delete from ".$this->prefix."photos where photo_id='$photo_id'");
           //$this->db->query("delete from ".$this->prefix."updates where type_id='$photo_id' AND action_id=29");
           common::delete_update($photo_id,29);
           common::delete_update($photo_id,31);           
          return $result;
      }
	  //full photo
      public function full_photo($photo_id, $album_id)
      {
          $result = $this->db->query("select * from ".$this->prefix."photos where photo_id='$photo_id' AND album_id='$album_id' AND object_type=-1 ");
          return $result;
      }
      public function get_count_fullshow($photo_id, $album_id)
      {
          $result = $this->db->query("select * from ".$this->prefix."photos where photo_id='$photo_id' AND album_id='$album_id' AND object_type=-1");
          $count_full = count($result);
          return $count_full;
      }
      //photo comment
      public function photo_comment($photo_id, $photo_text, $userid,$gid='')
      {
          $photo_text = html::specialchars($photo_text);
          if ($photo_text != "") 
		  {
              $this->db->query("update ".$this->prefix."photos set count_comment=count_comment+1 where photo_id='$photo_id'");
              $result = $this->db->query("insert into ".$this->prefix."photo_comment(photo_id,user_id,comments,photo_date) values ('$photo_id','$userid','$photo_text',sysdate())");   
              $post_id = $result->insert_id();
          			
				$res=$this->db->query("SELECT group_name FROM `".$this->prefix."groups` WHERE group_id='$gid'");
				$grp_name=$res["mysql_fetch_array"]->group_name;
				$this->update->updates_insert($userid,$photo_id,31,$grp_name,$post_id);
              return $result;
          } 
      }
      //show photo
      public function show_comment($photo_id)
      {
          $result = $this->db->query("select *,photo_date from ".$this->prefix."photo_comment left join ".$this->prefix.$this->usertable." on ".$this->prefix."photo_comment.user_id=".$this->prefix.$this->usertable.".id left join ".$this->prefix."users_profile on ".$this->prefix.$this->usertable.".id=".$this->prefix."users_profile.user_id having ".$this->prefix."photo_comment.photo_id='$photo_id' ");
          return $result;
      }
	  
	  //group join
	  public function group_join($gid,$user_id,$type)
	  {
	  	  $result=$this->db->query("select count(*) as count_total from ".$this->prefix."group_members where user_id='$user_id' AND group_id='$gid'");
		  if($result["mysql_fetch_array"]->count_total==0)
		  {
			  $res=$this->db->query("SELECT group_name FROM ".$this->prefix."groups WHERE group_id='$gid'");
			  $grp_name=$res["mysql_fetch_array"]->group_name; 	
		  	  //insert into group members table
			  if($type==1)
			  {
			  	//admin privilage
				$this->db->query("insert into ".$this->prefix."group_members(group_id,user_id,member_status)values('$gid','$user_id',-1)");
				$this->update->updates_insert($user_id,$gid,27,$grp_name);
				
			  }
			  else
			  {
				$this->db->query("insert into ".$this->prefix."group_members(group_id,user_id)values('$gid','$user_id')");
				$this->update->updates_insert($user_id,$gid,27,$grp_name);
			  }
			  Nauth::setMessage(1,$this->group_join);
		  }
		  else
		  {
		  	  Nauth::setMessage(-1,$this->already_join);
		  }
		  //update the members count in groups table
		  $this->db->query("update ".$this->prefix."groups set member_count=member_count+1 where group_id='$gid'");
	  }
	  //unjoin
	  public function group_unjoin($gid,$userid)
	  {
	  $result=$this->db->query("delete from ".$this->prefix."group_members where group_id='$gid' AND user_id='$userid'");
          common::delete_update($gid, 27);
	  $this->db->query("update ".$this->prefix."groups set member_count=member_count-1 where group_id='$gid'");
	  return $result;
	  }
	  //checking the current user in group
	  public function check_current_user_in_group($gid,$userid)
	  {
	  	$result=$this->db->query("select *,".$this->prefix."groups.user_id as creator_id from ".$this->prefix."group_members left join ".$this->prefix."groups on ".$this->prefix."group_members.group_id=".$this->prefix."groups.group_id  where ".$this->prefix."group_members.group_id='$gid' AND ".$this->prefix."group_members.user_id='$userid'");
		return $result;
	  }
	  //get group members
	  public function check_group_members_id($gid='')
	  {
		
		  $result=$this->db->query("select name,user_photo,".$this->prefix."group_members.user_id,last_name,city,cdesc,".$this->prefix."groups.group_id,".$this->prefix."groups.user_id as creator_id from ".$this->prefix."groups left join ".$this->prefix."group_members on ".$this->prefix."groups.group_id=".$this->prefix."group_members.group_id left join ".$this->prefix.$this->usertable." on ".$this->prefix."group_members.user_id=".$this->prefix.$this->usertable.".id left join ".$this->prefix."users_profile on ".$this->prefix.$this->usertable.".id=".$this->prefix."users_profile.user_id left join ".$this->prefix."country on ".$this->prefix."users_profile.country=".$this->prefix."country.cid where ".$this->prefix."groups.group_id='$gid' AND ".$this->prefix."group_members.member_status=1");
		  return $result;
	  }
	  
	  //get group members
	  public function get_group_members($gid='',$offset='',$noofpage='')
	  {
		  $result=$this->db->query("select name,user_photo,".$this->prefix."group_members.user_id,last_name,city,cdesc,".$this->prefix."groups.group_id  from ".$this->prefix."groups left join ".$this->prefix."group_members on ".$this->prefix."groups.group_id=".$this->prefix."group_members.group_id left join ".$this->prefix.$this->usertable." on ".$this->prefix."group_members.user_id=".$this->prefix.$this->usertable.".id left join ".$this->prefix."users_profile on ".$this->prefix.$this->usertable.".id=".$this->prefix."users_profile.user_id left join ".$this->prefix."country on ".$this->prefix."users_profile.country=".$this->prefix."country.cid where ".$this->prefix."groups.group_id='$gid' AND ".$this->prefix."group_members.member_status=1 limit $offset,$noofpage");
		  return $result;
	  }
	  
	  
	  //count the group members
	  public function get_group_members_count($gid)
	  {
	  	$result=$this->db->query("select * from ".$this->prefix."group_members where group_id='$gid' AND member_status=1");
		return count($result);
	  }
	  
	  //count the group request count
	  public function get_group_requests($gid)
	  {
		  $result=$this->db->query("select * from ".$this->prefix."group_members where group_id='$gid' AND member_status=-1");
		  return count($result);
	  }
	  //getting group requests
	  public function get_group_requests_members($gid,$offset='',$noofpage='')
	  {
		  $result=$this->db->query("select name,user_photo,".$this->prefix."group_members.user_id,last_name,city,cdesc,".$this->prefix."groups.group_id from ".$this->prefix."groups left join ".$this->prefix."group_members on ".$this->prefix."groups.group_id=".$this->prefix."group_members.group_id left join ".$this->prefix.$this->usertable." on ".$this->prefix."group_members.user_id=".$this->prefix.$this->usertable.".id left join ".$this->prefix."users_profile on ".$this->prefix.$this->usertable.".id=".$this->prefix."users_profile.user_id left join ".$this->prefix."country on ".$this->prefix."users_profile.country=".$this->prefix."country.cid where ".$this->prefix."groups.group_id='$gid' AND ".$this->prefix."group_members.member_status=-1 limit $offset,$noofpage");
		  return $result;

	  }
	  //approve the request
	  public function approve_requests($gid,$uid)
	  {
	  	$this->db->query("update ".$this->prefix."group_members set member_status=1 where user_id='$uid' AND group_id='$gid'");
	  }
	  //reject requests
	  public function reject_requests($gid,$uid)
	  {
		  $result=$this->db->query("delete from ".$this->prefix."group_members where user_id='$uid' AND group_id='$gid'");
		  return $result;
	  }
	  //get friends group
	  public function get_friends_list($userid)
	  {
	  $result=$this->db->query("select email from (SELECT user_id FROM ".$this->prefix."user_friend_list WHERE (friend_id ='$userid' AND STATUS =1 ) UNION SELECT friend_id FROM ".$this->prefix."user_friend_list WHERE ( user_id ='$userid' AND STATUS =1 ) ) as friends left join ".$this->prefix.$this->usertable." on ".$this->prefix.$this->usertable.".id=friends.user_id");
	  return $result;
	  }
	  //delete group
	  public function delete_group($gid)
	  {
		 $check_user=$this->db->query("SELECT user_id from ".$this->prefix."groups where group_id='$gid'");
	        if($check_user["mysql_fetch_array"]->user_id == $this->usr_id) 
	        {
	        $title = $this->db->query("select group_name from ".$this->prefix."groups where group_id='$gid'");
	        $grp_title = $title["mysql_fetch_object"]->group_name;
	         $result=$this->db->query("delete from ".$this->prefix."groups where group_id='$gid'");
	         common::delete_update($gid,26);
	         common::delete_update($gid,28);
	         common::delete_update($gid,27);	         	         
	          $this->db->query("delete from ".$this->prefix."updates where description = '$grp_title' AND action_id in (31,29,33,32)");
          	  return 1;
          	}
          	else
          	{
          	return 0;
          	}
		  
	  }
	  public function get_advanced_search_groups_list($key='',$category='',$offset,$noofpage='')
	  {
	        if($key!="" || $category!="")
	        {
	        
	        $query = "select group_id,group_photo,".$this->prefix."groups.user_id,group_name,group_desc,group_category,member_count,create_date,name,user_photo,group_category_name from ".$this->prefix."groups left join ".$this->prefix.$this->usertable." on ".$this->prefix."groups.user_id=".$this->prefix.$this->usertable.".id left join ".$this->prefix."users_profile on ".$this->prefix.$this->usertable.".id=".$this->prefix."users_profile.user_id left join ".$this->prefix."group_category on ".$this->prefix."groups.group_category=".$this->prefix."group_category.group_category_id  where group_status=1 AND ";
               
                if($key!="" || $category !="" )
                {
                        $query .="group_name like '%$key%' || group_desc like '%$key%' || location like '%$key%' AND  group_category='$category' ";
                }
                else if($key)
                {
                        $query .="group_name like '%$key%' || group_desc like '%$key%' || location like '%$key%' ";
                }
                else if($category)
                {
                        $query .="group_category = '$category' ";
                }
                else
                {
                        $query .="1=1";
                }
	        $query .= " order by group_id desc limit $offset,$noofpage";
	        
	        $result=$this->db->query($query);
		return $result;
		}
		
	  }
	   //count the groups
	 public function get_advanced_search_groups_count($key='',$category='')
	 {
	        if($key!="" || $category!="")
	        {
		 $query = "select group_id,group_photo,".$this->prefix."groups.user_id,group_name,group_desc,group_category,member_count,create_date,name,user_photo,group_category_name from ".$this->prefix."groups left join ".$this->prefix.$this->usertable." on ".$this->prefix."groups.user_id=".$this->prefix.$this->usertable.".id left join ".$this->prefix."users_profile on ".$this->prefix.$this->usertable.".id=".$this->prefix."users_profile.user_id left join ".$this->prefix."group_category on ".$this->prefix."groups.group_category=".$this->prefix."group_category.group_category_id  where group_status=1 AND ";
               
                if($key!="" || $category !="" )
                {
                        $query .="group_name like '%$key%' || group_desc like '%$key%' || location like '%$key%' AND  group_category='$category' ";
                }
                else if($key)
                {
                        $query .="group_name like '%$key%' || group_desc like '%$key%' || location like '%$key%' ";
                }
                else if($category)
                {
                        $query .="group_category = '$category' ";
                }
                else
                {
                        $query .="1=1";
                }
	        $query .= " order by group_id desc ";
	        
	        $result=$this->db->query($query);

		return count($result);
		}
	 }
	 
	  //get groups lists
	 public function get_search_groups_list($key='',$offset='',$noofpage='')
	 {
		$result=$this->db->query("select group_id,group_photo,".$this->prefix."groups.user_id,group_name,group_desc,group_category,member_count,create_date,name,user_photo,group_category_name from ".$this->prefix."groups left join ".$this->prefix.$this->usertable." on ".$this->prefix."groups.user_id=".$this->prefix.$this->usertable.".id left join ".$this->prefix."users_profile on ".$this->prefix.$this->usertable.".id=".$this->prefix."users_profile.user_id left join ".$this->prefix."group_category on ".$this->prefix."groups.group_category=".$this->prefix."group_category.group_category_id  where group_status=1 AND group_name like '%$key%' order by group_id desc limit $offset,$noofpage");
		return $result;
	 }	

	 //count the groups
	 public function get_search_groups_count($key='')
	 {
		$result=$this->db->query("select group_id,group_photo,".$this->prefix."groups.user_id,group_name,group_desc,group_category,member_count,create_date,name,user_photo,group_category_name from ".$this->prefix."groups left join ".$this->prefix.$this->usertable." on ".$this->prefix."groups.user_id=".$this->prefix.$this->usertable.".id left join ".$this->prefix."users_profile on ".$this->prefix.$this->usertable.".id=".$this->prefix."users_profile.user_id left join ".$this->prefix."group_category on ".$this->prefix."groups.group_category=".$this->prefix."group_category.group_category_id  where group_status=1  AND group_name like '%$key%'");
		return count($result);
	 }
	 
	  //delete comments { threads }
        public function delete_comment($cid,$fid)
        {
                $this->db->query("update ".$this->prefix."forum set posts=posts-1 where topic_id='$fid'");
                $result = $this->db->query( "delete from ".$this->prefix."forum_discussion where discuss_id='$cid' ");
				common::delete_update($fid, 33);
                return $result;
        }
        
}

?>
