 <?php defined('SYSPATH') or die('No direct script access.');
/**
 * Defines all Blog controls
 *
 * @package    Core
 * @author     Saranraj
 * @copyright  (c) 2010 Ndot.in
 */

class Photos_Controller extends Website_Controller 
{
	public $template = 'template/template';
	
	public function __construct()
	{
		 parent::__construct();
		 $this->module="photos";
		 $this->profile=new Profile_Model();
		 $this->uid = $this->input->get("uid");
		 if(empty($this->uid)){
		 	$this->uid=$this->userid;
		 }
		 
		 //$this->template->profile_info = $this->profile->profile_info($this->uid);
		 $this->model=new Photos_Model();
		 Nauth::is_login('',$this->docroot);
		
                 //user response messages
		$mes=Kohana::config('users_config.session_message');
		$this->upload_photo=$mes["upload_photo"];
		$this->add_comment=$mes["add_comment"];
		
		$this->delete_album=$mes["delete_album"];
		$this->delete_comment=$mes["delete_comment"];
		$this->update_change=$mes["update_change"];
		$this->delete_photo=$mes["delete_photo"];
		$this->not_authro=$mes["noacces"];
		$this->page_notfound= $mes["notfound"];
	}

	/** LIST OF ALL ALBUM **/
	
	public function index()
	{
		Nauth::is_login('',$this->docroot);
		$this->profile_info = $this->profile->profile_info($this->uid);
		$this->find_frnd_not =  $this->profile->find_frnd_not($this->uid,$this->userid,0);

		//pagination
		$page_no = $this->uri->last_segment();
		if($page_no == 0 || $page_no == 'index')
		$page_no = 1;
		$offset = 15*($page_no-1);
		$this->template->display_album = $this->model->display_album($this->uid,$offset,$page_no,15,count($this->find_frnd_not));		
		$this->total = $this->model->get_count_album($this->uid,count($this->find_frnd_not));
		
		$this->template->pagination = new Pagination(array(
			'base_url'       => 'photos',
			'uri_segment'    =>'index',
			'items_per_page' => 15,
			'total_items'    => $this->total,
			'style'         => 'classic' 
			)
		);

		$this->template->title = 'Album';
		$this->left = new View("template/left_menu");
		$this->right = new View("photos_content");
		$this->title_content = "Photos";
		$this->template->content = new View("template/template2");
	}
	
	//Friends photo
	public function friends_photo()
	{
		
		$user_id=$this->input->get('uid');
		
		//pagination
		$page_no=$this->uri->last_segment();
		if($page_no==0 || $page_no=='index')
		$page_no = 1;
		$offset=10*($page_no-1);

		$this->template->display_album=$this->model->friends_album($user_id,$offset,$page_no, 10);
		$this->total=$this->model->friends_count_album($user_id);
		$this->template->pagination = new Pagination(array
		(
		'base_url'       => 'photos',
		'uri_segment'    =>'index',
		'items_per_page' => 10,
		'total_items'    => $this->total,
		'style'         => 'classic' )
		);
		
	        // template code
		$this->template->title = 'Photos';
		$this->left=new View("template/left_menu");
		$this->right=new View("photos_content");
		$this->title_content = "Photos";
		$this->template->content=new View("template/template2");
	}
	
	//Create album
	public function create_album()
	{
		Nauth::is_login('',$this->docroot);
		$this->template->title = 'Create New Album';
		if($_POST){
			$title = $this->input->post('title');
			$share = $this->input->post('share');
			$desc = $this->input->post('description');
			$this->template->photos = $this->model->createalbum($this->userid,$title,$desc,$share);
			url::redirect($this->docroot.'photos/?uid='.$this->userid.'');
			die();
		}
	}
	
	//Delete album
	public function delete_album()
	{ 	
		//checking the login
		Nauth::is_login('',$this->docroot);
	 	$this->template->title = 'Delete the Album';
		$album_id = $this->input->get('album_id');
		$this->template->delete_album=$this->model->delete_album($album_id);
		if($this->template->delete_album){
			Nauth::setMessage(1,$this->delete_album);
			url::redirect($this->docroot.'photos/?uid='.$this->userid.'');
		}
		else{
			Nauth::setMessage(-1,$this->not_authro);
			url::redirect($this->docroot.'photos/');
		}
	}
	
	/** EDIT ALBUM **/
	
	public function editalbum($album_id = "")
	{
		$album_id = $this->input->get("album_id");
		$this->album_get_data = $this->model->view_albumphoto($album_id);
		if($this->album_get_data->count() == 0){
			Nauth::setMessage(-1,"Album does not Exist");
			url::redirect($this->docroot.'photos/?uid='. $this->userid.'');
		}
		if($this->album_get_data->current()->user_id !== $this->userid){
			Nauth::setMessage(-1,"Album does not Exist");
			url::redirect($this->docroot.'photos/?uid='. $this->userid.'');
		}
		$this->template->title = "Edit Album";
		if($_POST)
		{
			$this->template->title = 'Edit Album';
			$edit_title=$this->input->post('edit_title');
			$edit_description=$this->input->post('edit_description');
			$edit_description=html::specialchars($edit_description);
			$album_id=$this->input->get('album_id');
			$this->template->edit_album=$this->model->edit_album($album_id,$edit_title,$edit_description);
			Nauth::setMessage(1,$this->update_change);
			url::redirect($this->docroot.'photos/?uid='. $this->userid.'');
		}
		//url::redirect($this->docroot.'photos/view/?album_id='.$album_id.'');
		$this->title_content = " Edit Album ";
		$this->left=new View("template/left_menu");
		$this->right= new View("create_album");
		$this->template->content = new View("template/template2");
		
	}
	
	//upload photo
	public function upload()
	{    
		Nauth::is_login('',$this->docroot);
		if($_POST){
			$album_id = $this->input->post('album_id');
			$userid = $this->input->post('userid');
			if($userid != $this->userid){
				$upload_title = $_POST["photo_title"];
				$photo_name = $_FILES['upload_photo']['name']; 
				$this->template->insert_photo=$this->model->insert_photo($this->userid,$album_id,$upload_title,$photo_name);        
				$this->template->album_photo = $this->model->album_photo($album_id);
				foreach($this->template->album_photo as $row){
					$photo_id = $row->photo_id;
				}
				$this->tempalte->album_cover = $this->model->album_cover($album_id,$photo_id);
			}
			else{
				Nauth::setMessage(-1,"Album Owner only Upload Photos");
			}
			url::redirect($this->docroot."photos/view/?album_id=".$album_id);
			die();
		}
		// template code
		$this->template->title = 'Upload the Photos';
		$this->left=new View("template/left_menu");
		$this->right=new View("upload_photos");
		$this->title_content = "Upload photos";
		$this->template->content=new View("template/template2");
	}
	
	//View Full Photo
	public function zoom($album_id = "23",$photo_id = "")
	{
		$photo_id = $this->input->get('photo_id');
		$album_id = $this->input->get('album_id');
		$photo_text = $this->input->post('photo_comment');
		//pagination 
		$page_no=$this->uri->last_segment();
		if($page_no==0 || $page_no=='zoom')
		$page_no = 1;
		$offset=1*($page_no-1);
		$this->template->show_photo=$this->model->show_photo($album_id,$offset,$page_no, 1);
    	$this->photoid = $this->template->show_photo["mysql_fetch_array"]->photo_id;
		$this->total=$this->model->get_count_show($album_id);
		$this->template->pagination = new Pagination(array
		(
		'base_url'       => 'photos',
		'uri_segment'    =>'zoom',
		'items_per_page' => 1,
		'total_items'    => $this->total,
		'style'         => 'digg' )
		);

		$this->template->full_photo=$this->model->full_photo($this->photoid,$album_id);
		$this->template->show_comment=$this->model->show_comment($this->photoid);
		
		
	

		// template code 
		$this->template->title = "Photos:".$this->template->full_photo["mysql_fetch_array"]->photo_title;
		$this->left=new View("template/left_menu");
		$this->right=new View("full_photo");
		$this->title_content = $this->template->full_photo["mysql_fetch_array"]->photo_title;
		$this->template->content=new View("template/template2");
	}
	
	//Delete comment for photo
	public function delete_photocomment()
	{
		
		$comment_id=$this->input->get('comment_id');
		$photo_id=$this->input->get('photo_id');
		$this->template->delete_comment=$this->model->delete_photocomment($comment_id);
			if($this->template->delete_comment)
                        {
                                Nauth::setMessage(1,$this->delete_comment);
                                url::redirect($this->docroot.'photos/zoom/?photo_id='.$photo_id.'&album_id='.$album_id.'');
                        }
                        else
                        {
                                Nauth::setMessage(-1,$this->not_authro);
                                url::redirect($this->docroot.'photos');
                        }
		
	}
	
	//Post Comment
	public function post_comment()
	{

		$photo_id=$this->input->post('photo_id');
		$album_id=$this->input->post('album_id');
		$photo_text=$this->input->post('photo_comment');
		$redirect_url=$this->input->post('redirect_url');
		$this->template->photo_comment=$this->model->photo_comment($photo_id,$photo_text,$this->userid);
		Nauth::setMessage(1,$this->add_comment);
		url::redirect(''.$redirect_url.'');
			
	}

	//Show comment
	public function show_comment()
	{
		$this->template->title = 'Show-Comment';
		$photo_id=$this->input->get('photo_id');
		$album_id=$this->input->get('album_id');
		require_once Kohana::find_file('models','photos',TRUE,'php');
		$this->model= new Photos_Model();
		$session=Session::instance();
		$userid = $session->get('userid');
		if( !empty($userid)){
			$this->template->show_comment=$this->model->show_comment($photo_id);
			$view=new View("show_comment");
		}
		else{
			url::redirect($this->docroot.'users/login');
		}
		$this->template->content=$view;
	}
	
	//Create Album
	public function create_newalbum()
	{
		$this->template->title = 'Create New Album';
		$this->session=Session::instance();
		
		$userid = $this->session->get('userid');
		if(!empty($userid)){
			//$view = ;
		}
		else{
			url::redirect($this->docroot.'users/login');
		}
		//url::redirect($this->docroot.'photos/view/?album_id='.$album_id.'');
		$this->title_content = " Create New Album ";
		$this->left=new View("template/left_menu");
		$this->right= new View("create_album");
		$this->template->content = new View("template/template2");
	}
	
	//Edit photo
	public function edit_photo()
	{
		$this->template->title = 'Edit-Photo';
		$photo_id=$this->input->get('photo_id');
		$album_id=$this->input->get('album_id');
		$photo_title=$this->input->post('photo_name11');
		$album_cover=$this->input->post('album_cover');
		require_once Kohana::find_file('models','photos',TRUE,'php');
		$this->model= new Photos_Model();
		$this->session=Session::instance();
		$userid = $this->session->get('userid');
		if(!empty($userid)){
			$this->template->edit_photo=$this->model->edit_photo($photo_id,$photo_title);
			$this->session->set('Msg','Photo changes has been updated');
			$this->tempalte->album_cover=$this->model->album_cover($album_id,$album_cover);
			$view=new View("photos_content");
		}
		else{
			url::redirect($this->docroot.'users/login');
		}
		url::redirect($this->docroot.'photos/view/?album_id='.$album_id.'');
		$this->template->content=$view;
	}
	
	//Delete photo
	public function delete_photo()
	{
		 Nauth::is_login('',$this->docroot);
		 $this->template->title = 'Delete-Photo';
		 $photo_id=$this->input->get('photo_id');
		 $album_id=$this->input->get('album_id');
		
	 	 $this->template->delete_photo=$this->model->delete_photo($photo_id,$this->userid);
		 Nauth::setMessage(1,$this->delete_photo);

		 url::redirect($this->docroot.'photos/view/?album_id='.$album_id.'');
	
	}
	
	//Display album photos
	public function view()
	{	
		//checking the login
		Nauth::is_login('',$this->docroot);
		$album_id = $this->input->get('album_id');
		$view_albumphoto = $this->model->view_albumphoto($album_id);
		if($view_albumphoto->count() == 0){
			url::redirect($this->docroot.'photos/');
			die();
		}
		$uid = $view_albumphoto->current()->user_id;
		if($uid !== $this->userid){
			$this->profile_info = $this->profile->profile_info($uid);
			$this->find_frnd_not =  $this->profile->find_frnd_not($uid, $this->userid, 0);
			$album_per = $view_albumphoto->current()->album_permision;
			
			if($album_per == -1){
				Nauth::setMessage(-1,"Only Friends View Album");
				url::redirect($this->docroot.'photos/');
			}
			elseif($album_per == 1){
				if(count($this->find_frnd_not) == 0){
					Nauth::setMessage(-1,"Only Friends View Album");
					url::redirect($this->docroot.'photos/');
				}
			}
		}
		//pagination
		$page_no=$this->uri->last_segment();
		if($page_no==0 || $page_no=='view_albumphoto')
		$page_no = 1;
		$offset=15*($page_no-1);
		$this->template->show_photo = $this->model->show_photo($album_id,$offset,$page_no, 15);
		$this->photo_total = $this->model->get_count_show($album_id); 
		$this->template->pagination = new Pagination(array
		(
			'base_url'       => 'photos',
			'uri_segment'    =>'view',
			'items_per_page' => 15,
			'total_items'    => $this->photo_total,
			'style'         => 'classic' )
		);
		
		$this->template->view_albumphoto =  $view_albumphoto;
		$this->template->title = 'Album Photos: '.$view_albumphoto->current()->album_title;
		$this->left = new View("template/left_menu");
		$this->right = new View("view_albumphoto");
		$this->title_content = "Album Photos: ".$view_albumphoto->current()->album_title."(".$this->photo_total.")";
		$this->template->content = new View("template/template2");
		
	}
	
	//get the album search
    public function commonsearch()
   	{
		$key=html::specialchars($this->input->get('search_value'));
		$page_no=$this->uri->last_segment();
		if($page_no==0 || $page_no=='commonsearch')
		$page_no = 1;
		$offset=10*($page_no-1);
	
		$this->template->display_album=$this->model->search_album($key,$this->userid,$offset,$page_no,10);
		$this->total=$this->model->search_album_count($key,$this->userid);
		
		 $this->template->pagination = new Pagination(array
		 (
			 'base_url'       => 'photos',
			 'uri_segment'    =>'commonsearch',
			 'items_per_page' => 10,
			 'total_items'    => $this->total,
			 'style'         => 'classic' )
			 );	
	 
	
		// template code
		$this->template->title = 'Photos';
		$this->left=new View("template/left_menu");
		$this->right=new View("photos_content");
		$this->title_content = "Photos";
		$this->template->content=new View("template/template2");

	} 
	 //delete photo comment
   	public function delete_comment()
   	{
	    
	    $cid=$this->input->get('cid');
	    $pid=$this->input->get('pid');
	    $aid=$this->input->get('aid');
	    $this->delete = $this->model->delete_photo_comment($cid,$pid);
	    if($this->delete)
	    {
	            Nauth::setMessage(1,$this->delete_comment);
	            url::redirect($this->docroot.'photos/zoom/?album_id='.$aid.'');
	    }
	    
	}
}
?>
